#declare Test =
function {
        pow (f_noise3d (x,y,z), 0.3)
        *f_noise3d (x*5,y*5,z*5)
        *pow (f_noise3d (x*20,y*20,z*20), 0.3)
} 

#declare Test2 =
function {
        pow (f_noise3d (x,y,z), 2)
        *f_noise3d (x*5,y*5,z*5)
        *pow (f_noise3d (x*20,y*20,z*20), 0.3)
}

#macro RBoxM (W, H, L)   

isosurface {
        function {(pow (x, (12*W))+pow (y, (2*H))+pow (z, (12*L)))}
        threshold 1
        contained_by {box {-1, 1}}
        translate <1,1,1>
        scale 0.5
        scale <W,H,L>   
}    

#end 
                     
#macro FeatheredSphere (Center,Radius,Power,Scale,Rotate,Tanslate)  

sphere {Center, Radius, Power*0.5 scale Scale rotate Rotate translate Tanslate}  
sphere {Center, Radius*1.1, Power*0.25 scale Scale rotate Rotate translate Tanslate}
sphere {Center, Radius*1.2, Power*0.25 scale Scale rotate Rotate translate Tanslate} 

#end 
   
#macro FeatheredSphere2 (Center,Radius,Power,Scale,Rotate,Tanslate)  

sphere {Center, Radius, Power*0.5 scale Scale rotate Rotate translate Tanslate}  
sphere {Center, Radius*1.2, Power*0.25 scale Scale rotate Rotate translate Tanslate}
sphere {Center, Radius*1.4, Power*0.25 scale Scale rotate Rotate translate Tanslate}  

#end    
                
#declare Carapace_Part1 = 
union {
        blob {
                threshold 0.1
                sphere {0, 1, 0.5}
                sphere {0, 1.1, 0.25}
                sphere {0, 1.2, 0.25}
                FeatheredSphere (0, 0.9005, -0.5, 0, 0, 0)  
                FeatheredSphere (0, 0.901, -0.5, 0, 0, 0) 
                FeatheredSphere2 (0, 0.425, -1/6, <1,4,1>, 0, y)    
                FeatheredSphere2 (0, 0.4, -1/6, <1,4,1>, 0, y) 
                FeatheredSphere2 (0, 1, -0.1, <4,1/2,4>, 0, -y*0.5)
                FeatheredSphere2 (0, 1, -0.5, <4,1/2,4>, 0, -y*0.5-0.1) 
                FeatheredSphere2 (0, 1, -1/60, <0.125/8,4,4>, 0, 0)
                FeatheredSphere2 (0, 1, -1/60, <0.125/7,4,4>, 0, 0)                                
                FeatheredSphere2 (0, 1, -1/60, <0.125/4,0.5,4>, 0, 0)
                FeatheredSphere2 (0, 1, -1/60, <0.125/3,0.5,4>, 0, 0)                       
                FeatheredSphere2 (0, 0.3, -1/60, <0.25,0.175,0.25>, 0, <0,0.375,-0.625>)
                FeatheredSphere2 (0, 0.4, -1/60, <0.25,0.175,0.25>, 0, <0,0.375,-0.625>)
                FeatheredSphere2 (0, 0.5, -1/60, <0.25,0.175,0.25>, 0, <0,0.375,-0.625>)                          
                FeatheredSphere2 (0, 0.3, -1/60, <0.75,0.3875,1>, 0, <0,0,-0.625>)
                FeatheredSphere2 (0, 0.4, -1/60, <0.75,0.3875,1>, 0, <0,0,-0.625>)
                FeatheredSphere2 (0, 0.5, -1/60, <0.75,0.3875,1>, 0, <0,0,-0.625>)                           
                FeatheredSphere2 (0, 0.3, -1/48, <0.5,0.375,100>, 45*y, <-0.2,0.3,0>)
                FeatheredSphere2 (0, 0.4, -1/48, <0.5,0.375,100>, 45*y, <-0.2,0.3,0>)
                FeatheredSphere2 (0, 0.5, -1/48, <0.5,0.375,100>, 45*y, <-0.2,0.3,0>)
                FeatheredSphere2 (0, 0.3, -1/48, <0.5,0.375,100>, -45*y, <0.2,0.3,0>)
                FeatheredSphere2 (0, 0.4, -1/48, <0.5,0.375,100>, -45*y, <0.2,0.3,0>)
                FeatheredSphere2 (0, 0.5, -1/48, <0.5,0.375,100>, -45*y, <0.2,0.3,0>)  
                FeatheredSphere (0, 0.6, 1/48, <0.5,0.375,100>, 45*y, <-0.2,0.3,0>)
                FeatheredSphere (0, 0.6, 1/48, <0.5,0.375,100>, -45*y, <0.2,0.3,0>)
                scale <1,1.1,1>
        }   
        bounded_by {cylinder {-0.1*y, y*0.6, 0.875}}
        clipped_by {bounded_by}
}

#declare Eye1_Part1 = 
blob {
        threshold 0.1
        cylinder {-x/3, x/3, 1, 1}
        cylinder {-x/3, x/3, 0.75, -1 scale <1,1,2>} 
        cylinder {-x/3, x/3, 0.625, -2 scale <1,1,2>}    
        sphere {0, 1.75, 0.2}
}
  
#declare Eye1_Part2 = 
blob {
        threshold 0.1
        cylinder {-x/3, x/3, 0.75, 1}
        sphere {0, 2, 0.125}
}

#declare Eye1 =
union {
        object {Eye1_Part1} 
        object {
                Eye1_Part2 
                pigment {color rgbt 0.9}
                finish {ambient 0 diffuse 2 phong 3}   
                interior {
                        media {
                                emission rgb fac*<1,0.1,0.3>*450
                                density {
                                        spherical  
                                        color_map {
                                                [0      rgb 0]
                                                [2/3    rgb 0.75]
                                                [1      rgb 20]
                                        }
                                        scale 2/3
                                }
                        }
                }
                hollow
        }
        hollow
}
  
#declare Eye2_Part1 =
union {
        torus {0.5, 0.25 scale <1,4,1>}
        cylinder {-y*2, 0, 0.75} 
}

#declare Eye2_Part2 = cylinder {0, y*1.75, 0.625 scale <1,0.5,1>}

#declare Eye2 =
union {
        object {Eye2_Part1}    
        object {
                Eye2_Part2
                pigment {color rgbt 0.9}
                finish {ambient 0 diffuse 2 phong 3}   
                interior {
                        media {
                                emission rgb fac*<0.2,0.1,1>*900
                                density {
                                        spherical
                                        color_map {
                                                [0      rgb 0]
                                                [2/3    rgb 1]
                                                [1      rgb 20]
                                        }
                                        scale 0.5      
                                        translate 0.75*y
                                }
                        }
                }
                hollow
        }     
        scale 0.25
        rotate -90*x
}

#declare Detail1 =
union {
        object {
                RBoxM (1, 1, 1)
                scale <0.5,0.5,1.5> 
                translate <-0.25,-0.25,-0.25>
                rotate 120*x
        }  
        object {
                RBoxM (1, 1, 1.25)
                scale <0.25,0.5,1.5> 
                translate <-0.125,-0.25,-0.25>
                rotate 120*x
                translate -y*0.75
        }
        object {
                RBoxM (1, 1, 1.5)
                scale <1/2,1/2,1.5> 
                translate <-0.25,-0.25,-0.25>
                rotate 120*x  
                translate -y
        } 
        scale 0.25
}

#declare Detail2 =
union {
        torus {0.5, 0.25 scale <1,4,1>}  
        cylinder {-y*2, 0, 0.75}    
        #declare C = 0;
        #while (C < 360)
                blob {
                        threshold 0.1
                        cylinder {y*0.75, -y, 0.125, 1 translate 0.625*z rotate C*y}
                }
                #declare C = C+20;
        #end
        scale 0.25
        rotate -90*x
}

#declare Detail2a =
union {
        torus {0.5, 0.25 scale <1,4,1>}  
        torus {0.375, 0.25 scale <1,4,1>}
        cylinder {-y*2, 0, 0.75} 
        difference {
                cylinder {y, 0, 0.5}
                cylinder {y*2, 0, 0.375}  
        }
        scale 0.25 
        rotate -90*x
}

#declare Detail2b =
union {
        torus {0.5, 0.25 scale <1,4,1>}  
        torus {0.25, 0.25 scale <1,4,1>}
        cylinder {-y*2, 0, 0.75} 
        difference {
                cylinder {y, 0, 0.5}
                cylinder {y*2, 0, 0.25}  
        }
        scale 0.25 
        rotate -90*x
}

#declare Detail2c =
union {
        torus {0.5, 0.25 scale 4*y}  
        torus {0.25, 0.25 scale 4*y translate 0.25*z} 
        torus {0.25, 0.25 scale 4*y translate 0.25*z rotate 120*y}
        torus {0.25, 0.25 scale 4*y translate 0.25*z rotate -120*y}
        cylinder {-y*2, 0, 0.75} 
        difference {
                cylinder {y, 0, 0.5}
                cylinder {y*2, 0, 0.25 translate 0.25*z}   
                cylinder {y*2, 0, 0.25 translate 0.25*z rotate 120*y}
                cylinder {y*2, 0, 0.25 translate 0.25*z rotate -120*y}
        }
        scale 0.25 
        rotate -90*x
}
 
#declare Detail2d =
union {
        torus {0.5, 0.25 scale 4*y}  
        torus {0.375, 0.25 scale 4*y}
        cylinder {-y*2,0, 0.75} 
        cylinder {y,0, 0.5}
        scale 0.25 
        rotate -90*x
}

#undef Test

#declare Test = 
function {
        pow (f_noise3d (x,y,z), 1.5)
        *f_noise3d (x*2,y*2,z*2)
        *f_noise3d (x*3,y*3,z*3)
        *f_noise3d (x*8,y*8,z*8)
        *f_noise3d (x*200,y*100,z*200)
}

#undef Test2 

#declare Test2 = 
function {
        pow (f_noise3d (x,y,z), 0.5)
        *f_noise3d (x*2,y*2,z*2)
        *f_noise3d (x*8,y*8,z*8)
        *f_noise3d (x*3+5,y*3+5,z*3+5)
        *f_noise3d (x*60,y*60,z*60)
        *f_noise3d (x*200,y*100,z*200)
} 

#declare CopperBot = 
union {
        object {Carapace_Part1}
        sphere {
                0, 0.5 
                scale <1,0.5,1> 
                translate y/3 
        }   
        union {
                torus {0.4875, 0.025 translate 0.5*y}
                torus {0.45, 0.0125 translate 0.5*y}
                torus {0.4125, 0.025 translate 0.4875*y}
                object {Eye1 scale 0.1 rotate 10*x translate <0,0.4,-0.575>}  
                object {Eye2 scale 0.25 rotate -20*y translate <0.2,0.1,-0.575>}  
                object {Eye2 scale 0.25 rotate <-20,-30,0> translate <0.25,0.125/2,-0.55>} 
                object {Eye2 scale 0.25 rotate <0,10,0> translate <-0.15,0.1,-0.6>}
                object {Eye2 scale 0.25 rotate <0,15,0> translate <-0.25,0.0875,-0.6>}
                //Middle Stuff                                                                   
                object {Detail2 scale 0.25 translate <0,-0.025,-0.6>}
                object {Detail2c scale 0.15 rotate <0,0,90> translate <0,-0.025,-0.675>} 
                object {Detail2 scale 0.4 rotate <-30,15,0> translate <-0.075,0,-0.6>}
                object {Detail2 scale <1,1,0.5>*0.4 rotate <-30,-15,0> translate <0.075,0,-0.6>} 
                //Right Stuff
                object {Detail2a scale 0.25 rotate <-15,15,0> translate <-0.06,0.1,-0.625>} 
                object {Detail2 scale 0.25 rotate <0,0,0> translate <-0.08,0.165,-0.625>}
                object {Detail2b scale 0.15 rotate <0,0,0> translate <-0.08,0.165,-0.7>} 
                object {Detail2c scale 0.25 rotate <-10,30,0> translate <-0.2,0,-0.6>}
                object {Detail2d scale 0.25 rotate <-10,35,0> translate <-0.3,0.025,-0.55>}
                object {Detail2 scale 0.1 rotate <0,30,0> translate <-0.25,0,-0.6>}
                object {Detail2 scale 0.1 rotate <0,30,0> translate <-0.25,0.05,-0.6>} 
                object {Detail2 scale 0.1 rotate <-30,40,0> translate <-0.375,0,-0.55>}  
                object {Detail2 scale 0.1 rotate <-30,45,0> translate <-0.4,0,-0.5>}  
                object {Detail2 scale 0.1 rotate <0,40,0> translate <-0.375,0.025,-0.55>}  
                object {Detail2 scale 0.1 rotate <0,45,0> translate <-0.4,0.025,-0.5>}   
                //Left Stuff
                object {Detail2 scale 0.1 rotate <0,0,0> translate <0.1,0.135,-0.7>}
                object {Detail2 scale 0.1 rotate <0,0,0> translate <0.1,0.1,-0.7>}   
                object {Detail2 scale 0.1 rotate <0,0,0> translate <0.0625,0.14,-0.7>}
                object {Detail2 scale 0.1 rotate <0,0,0> translate <0.0625,0.105,-0.7>} 
                object {Detail2a scale 0.25 rotate <5,5,0> translate <0.08,0.1875,-0.625>} 
                object {Detail2d scale 0.175 rotate <20,10,0> translate <0.15,0.15,-0.625>}
                object {Detail2d scale 0.2 rotate <-10,-20,0> translate <0.175,0.025,-0.625>} 
                object {Detail2c scale 0.2 rotate <-10,-20,0> translate <0.35,0.05,-0.575>}
                object {Detail2 scale 0.1 rotate <-5,-20,0> translate <0.3,0.075,-0.575>}
                object {Detail2 scale 0.1 rotate <-5,-20,0> translate <0.4,0.075,-0.575>}
                object {Detail2d scale 0.2 rotate <-5,-20,0> translate <0.35,0.1,-0.55>}  
                //Under Wire Connector
                object {Detail2 scale 0.25 rotate <-15,-10,0> translate <0.075,-0.05,-0.425>} 
                //Side Wide Ports 
                object {Detail2c scale 0.75 scale <1,1,1/6> rotate <20,-45,0> translate <0.55,0.325,-0.4>}
                object {Detail2 scale 0.75 scale <1,1,1/3> rotate <20,45,0> translate <-0.55,0.325,-0.4>}
                //Inner Armor
                union {
                        difference {
                                sphere {0, 0.625}
                                disc {0, -y, 1 translate 0.45}       
                                disc {0, y, 1} 
                        }  
                        cylinder {0, -0.025*y, 0.6}
                        torus {0.6, 0.025}
                }   
                union {
                        object {Detail1 scale 0.575*x translate (0.065+0.065/2)*x}     
                        object {Detail1 scale 0.575*x translate (0.065-0.065/2)*x}
                        object {Detail1 scale 0.575*x translate (-0.065+0.065/2)*x}     
                        object {Detail1 scale 0.575*x translate (-0.065-0.065/2)*x}
                        scale 1/3
                        translate <0,0.275,-0.6>
                }
        }  

        #declare Tube1 =  
        spline {
                quadratic_spline
                0,      <0.1,0.135,-0.725>        
                0.25,   <0.175,0,-0.8>    
                0.5,    <0.125,-0.15,-0.75>
                0.75,   <0.15,-0.1,-0.65>    
                1,      <0.075,-0.05,-0.5>    
        }
        
        #declare Tube2 = 
        spline {
                quadratic_spline
                0,      <0.1,0.1,-0.725>        
                0.25,   <0.15,-0.05,-0.8>
                0.5,    <0.1,-0.15,-0.7>      
                0.75,   <0.075,-0.1,-0.6>   
                1,      <0.05,-0.05,-0.5>    
        }
        
        #declare Tube3 =
        spline {
                quadratic_spline
                0,      <0.0625,0.14,-0.725>        
                0.25,   <0.1,0.05,-0.8>
                0.5,    <0.075,0,-0.8> 
                0.75,   <0.04,-0.15,-0.7> 
                1,      <0.05,-0.05,-0.5>    
        }
        
        #declare Tube4 =
        spline {
                quadratic_spline
                0,      <0.0625,0.105,-0.725>        
                0.25,   <0.15,0.05,-0.775>
                0.5,    <0.05,-0.05,-0.75>
                0.75,   <0.075,-0.125,-0.65>    
                1,      <0.05,-0.05,-0.5>    
        }
        
        union {
                blob { 
                        threshold 0.1 
                        #local c = 0;
                        #while (c < 50)     
                                sphere {0, 0.0125, 1 translate Tube1 (c*0.02)}
                                #local c = c+1/3;
                        #end 
                }
                blob { 
                        threshold 0.1 
                        #local c = 0;
                        #while (c < 50)     
                                sphere {0, 0.0125, 1 translate Tube2 (c*0.02)}
                                #local c = c+1/3;
                        #end 
                }
                blob { 
                        threshold 0.1 
                        #local c = 0;
                        #while (c < 50)     
                                sphere {0, 0.0125, 1 translate Tube3 (c*0.02)}
                                #local c = c+1/3;
                        #end 
                }
                blob { 
                        threshold 0.1 
                        #local c = 0;
                        #while (c < 50)     
                                sphere {0, 0.0125, 1 translate Tube4 (c*0.02)}
                                #local c = c+1/3;
                        #end 
                }
        }               
} 
 

  
