// IMT Metropolis Carrier
//
// AUthor - Oliver Harlow - Crayon-World Design Bureau
// www.twoflower.fsnet.co.uk/crayonworld  
// e-mail : crayons@twoflower.fsnet.co.uk
//
// Designed for - Interstellar Master Traders
// Find them at - www.hightown.demon.co.uk/IMT   
//
//
// Copyright (C) 2003 Oliver Harlow
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public Licenseas published
// by the Free Software Foundation; either version 2 of the License,
// or (at your option) any later version.

// Zeger Knaepen  no spherical-greebles  http://news.povray.org/povray.binaries.images/attachment/%3C44738fd7@news.povray.org%3E/us-ascii

// material {T_1} - pigment {Red}
// material {T_2} - pigment {Gray}
// material {T_3} - pigment {White} 
// material {T_4} - pigment {Yellow} 
// material {T_5} - pigment {Skyblue} 
// material {T_6} - pigment {Orange}

#declare Kleur =     <1,0.1,0>*0.25+0.75;
#declare Vuilkleur = <0.75,0.2,0>*0.25+0.375;

#declare Gewoon_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.8]
		}
		rotate x*90
		translate -0.5
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Gewoon_heel_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.6]
		}
		rotate x*90
		translate -0.5
		//scale <4*6,1,3*6>
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Scar =
texture {
	pigment {
		crackle form <1,0,0>
		color_map {
			[0      rgbt <0.1,0.01,0,0.8>]
			[0.2    rgbt <0.1,0.01,0,1>]
		}
		scale 0.5
		turbulence 0.2
		lambda 3
		scale 4
	}
	normal {dents 0.1*2}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare BS = 8*2;

#declare T_1 =
material {
	texture {
		pigment {
			average
			pigment_map {
				[1      cells
					pigment_map {
						[0      cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							scale 0.5
						]
						[.4     cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					color_map {
						[0      rgb 0.8*Kleur]
						[1      rgb     Kleur]
					}
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.25
		}
		normal {
			average
			normal_map {
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 0.25
				]
				[1      cells
					bump_size 0.125*BS
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.125/8
		}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
		scale 5*3
	}
	texture {Scar		  scale <0.25,0.250,1>*3}
	texture {Gewoon_vuil      scale <0.50,0.250,1>*3}
	texture {Gewoon_heel_vuil scale <0.25,0.125,0.7>*3}
	scale 0.4*10
	interior {ior 2.4}
}

#declare Kleur =     <1,1,0.9>*0.5*0.25+0.75;
#declare Vuilkleur = <0.75,0.8,0.6>*0.5*0.25+0.3;

#declare Gewoon_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.8]
		}
		rotate x*90
		translate -0.5
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Gewoon_heel_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.6]
		}
		rotate x*90
		translate -0.5
		//scale <4*6,1,3*6>
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Scar =
texture {
	pigment {
		crackle form <1,0,0>
		color_map {
			[0      rgbt <0.1,0.01,0,0.8>]
			[0.2    rgbt <0.1,0.01,0,1>]
		}
		scale 0.5
		turbulence 0.2
		lambda 3
		scale 4
	}
	normal {dents 0.1*2}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare BS = 8*2;

#declare T_2 =
material {
	texture {
		pigment {
			average
			pigment_map {
				[1      cells
					pigment_map {
						[0      cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							scale 0.5
						]
						[.4     cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					color_map {
						[0      rgb 0.8*Kleur]
						[1      rgb     Kleur]
					}
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.25
		}
		normal {
			average
			normal_map {
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 0.25
				]
				[1      cells
					bump_size 0.125*BS
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.125/8
		}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
		scale 5*3
	}
	texture {Scar		  scale <0.25,0.250,1>*3}
	texture {Gewoon_vuil      scale <0.50,0.250,1>*3}
	texture {Gewoon_heel_vuil scale <0.25,0.125,0.7>*3}
	scale 0.4*10
	interior {ior 2.4}
}

#declare Kleur =     <1,1,0.9>*0.25+0.75;
#declare Vuilkleur = <0.75,0.8,0.6>*0.25+0.6;

#declare Gewoon_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.8]
		}
		rotate x*90
		translate -0.5
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Gewoon_heel_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.6]
		}
		rotate x*90
		translate -0.5
		//scale <4*6,1,3*6>
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Scar =
texture {
	pigment {
		crackle form <1,0,0>
		color_map {
			[0      rgbt <0.1,0.01,0,0.8>]
			[0.2    rgbt <0.1,0.01,0,1>]
		}
		scale 0.5
		turbulence 0.2
		lambda 3
		scale 4
	}
	normal {dents 0.1*2}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare BS = 8*2;

#declare T_3 =
material {
	texture {
		pigment {
			average
			pigment_map {
				[1      cells
					pigment_map {
						[0      cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							scale 0.5
						]
						[.4     cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					color_map {
						[0      rgb 0.8*Kleur]
						[1      rgb     Kleur]
					}
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.25
		}
		normal {
			average
			normal_map {
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 0.25
				]
				[1      cells
					bump_size 0.125*BS
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.125/8
		}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
		scale 5*3
	}
	texture {Scar		  scale <0.25,0.250,1>*3}
	texture {Gewoon_vuil      scale <0.50,0.250,1>*3}
	texture {Gewoon_heel_vuil scale <0.25,0.125,0.7>*3}
	scale 0.4*10
	interior {ior 2.4}
}

#declare Kleur =     <1,0.75,0>*0.25+0.75;
#declare Vuilkleur = <0.75,0.52,0>*0.25+0.55;

#declare Gewoon_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.8]
		}
		rotate x*90
		translate -0.5
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Gewoon_heel_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.6]
		}
		rotate x*90
		translate -0.5
		//scale <4*6,1,3*6>
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Scar =
texture {
	pigment {
		crackle form <1,0,0>
		color_map {
			[0      rgbt <0.1,0.01,0,0.8>]
			[0.2    rgbt <0.1,0.01,0,1>]
		}
		scale 0.5
		turbulence 0.2
		lambda 3
		scale 4
	}
	normal {dents 0.1*2}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare BS = 8*2;

#declare T_4 =
material {
	texture {
		pigment {
			average
			pigment_map {
				[1      cells
					pigment_map {
						[0      cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							scale 0.5
						]
						[.4     cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					color_map {
						[0      rgb 0.8*Kleur]
						[1      rgb     Kleur]
					}
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.25
		}
		normal {
			average
			normal_map {
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 0.25
				]
				[1      cells
					bump_size 0.125*BS
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.125/8
		}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
		scale 5*3
	}
	texture {Scar		  scale <0.25,0.250,1>*3}
	texture {Gewoon_vuil      scale <0.50,0.250,1>*3}
	texture {Gewoon_heel_vuil scale <0.25,0.125,0.7>*3}
	scale 0.4*10
	interior {ior 2.4}
}

#declare Kleur =     <0,0.6,1>*0.25+0.75;
#declare Vuilkleur = <0,0.6,1>*0.6*0.25+0.45;

#declare Gewoon_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.8]
		}
		rotate x*90
		translate -0.5
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Gewoon_heel_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.6]
		}
		rotate x*90
		translate -0.5
		//scale <4*6,1,3*6>
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Scar =
texture {
	pigment {
		crackle form <1,0,0>
		color_map {
			[0      rgbt <0.1,0.01,0,0.8>]
			[0.2    rgbt <0.1,0.01,0,1>]
		}
		scale 0.5
		turbulence 0.2
		lambda 3
		scale 4
	}
	normal {dents 0.1*2}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare BS = 8*2;

#declare T_5 =
material {
	texture {
		pigment {
			average
			pigment_map {
				[1      cells
					pigment_map {
						[0      cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							scale 0.5
						]
						[.4     cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					color_map {
						[0      rgb 0.8*Kleur]
						[1      rgb     Kleur]
					}
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.25
		}
		normal {
			average
			normal_map {
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 0.25
				]
				[1      cells
					bump_size 0.125*BS
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.125/8
		}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
		scale 5*3
	}
	texture {Scar		  scale <0.25,0.250,1>*3}
	texture {Gewoon_vuil      scale <0.50,0.250,1>*3}
	texture {Gewoon_heel_vuil scale <0.25,0.125,0.7>*3}
	scale 0.4*10
	interior {ior 2.4}
}

#declare Kleur =     <0,1,0.6>*0.25+0.75;
#declare Vuilkleur = <0.1,0.4,0.3>*0.25+0.3;

#declare Gewoon_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.8]
		}
		rotate x*90
		translate -0.5
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Gewoon_heel_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.6]
		}
		rotate x*90
		translate -0.5
		//scale <4*6,1,3*6>
		translate z*2
	}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare Scar =
texture {
	pigment {
		crackle form <1,0,0>
		color_map {
			[0      rgbt <0.1,0.01,0,0.8>]
			[0.2    rgbt <0.1,0.01,0,1>]
		}
		scale 0.5
		turbulence 0.2
		lambda 3
		scale 4
	}
	normal {dents 0.1*2}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
}

#declare BS = 8*2;

#declare T_6 =
material {
	texture {
		pigment {
			average
			pigment_map {
				[1      cells
					pigment_map {
						[0      cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							scale 0.5
						]
						[.4     cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb     Kleur]
							}
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					color_map {
						[0      rgb 0.8*Kleur]
						[1      rgb     Kleur]
					}
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.25
		}
		normal {
			average
			normal_map {
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 0.25
				]
				[1      cells
					bump_size 0.125*BS
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.125/8
		}
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0.2, 1 metallic}
	                }
		scale 5*3
	}
	texture {Scar		  scale <0.25,0.250,1>*3}
	texture {Gewoon_vuil      scale <0.50,0.250,1>*3}
	texture {Gewoon_heel_vuil scale <0.25,0.125,0.7>*3}
	scale 0.4*10
	interior {ior 2.4}
}

/// main crossbeam element
#declare crossbeam =
union {
        cylinder {<4,0,-4>, <-4,0, 4>, 0.2} 
        cylinder {<4,0, 4>, <-4,0,-4>, 0.2} 
}

// Box section 2 - no middle crossbeam            
#declare boxsect2 = 
union { 
        object {crossbeam translate  4*y}
        object {crossbeam translate -4*y}
        object {crossbeam translate -4*y rotate 90*x} 
        object {crossbeam translate  4*y rotate 90*x}  
        object {crossbeam translate  4*y rotate 90*y rotate 90*z}
        object {crossbeam translate -4*y rotate 90*y rotate 90*z}  
} 
// END   Box section 2 - no middle crossbeam  


/// thicker crossbeam element
#declare crossbeamt = 
union {
        cylinder {<4,0,-4>, <-4,0, 4>, 0.5} 
        cylinder {<4,0, 4>, <-4,0,-4>, 0.5} 
}

// Box section 3 - thicker
#declare boxsect3 = union { 
        object {crossbeamt translate  4*y}
        object {crossbeamt translate -4*y}
        object {crossbeamt translate -4*y rotate 90*x} 
        object {crossbeamt translate  4*y rotate 90*x}  
        object {crossbeamt translate  4*y rotate 90*y rotate 90*z}
        object {crossbeamt translate -4*y rotate 90*y rotate 90*z}  
} 
// END   Box section 3 - thicker 



// a general flat strut section
#declare flatstrut = 
union {
        object {crossbeam }
        object {crossbeam translate   8*z}
        object {crossbeam translate  16*z}
        object {crossbeam translate  24*z}
        object {crossbeam translate  -8*z}
        object {crossbeam translate -16*z}
        object {crossbeam translate -24*z}
        object {crossbeam translate -32*z}
        material {T_6}
}
/// end flat strut

// a general flat strut section
#declare flatstrut2 = 
union {
        object {crossbeam }
        object {crossbeam translate   8*z}
        object {crossbeam translate  16*z}
        object {crossbeam translate  24*z}
        object {crossbeam translate  -8*z}
        object {crossbeam translate -16*z}
        material {T_6}
}
/// end flat strut

 //spotlight
#declare spotlamp = 
merge {
        difference {
                cone {<0,0,0.5>, 0, <0,0,-0.5>, 1}
                cone {<0,0,0.45>, 0, <0,0,-0.5>, 0.9 open 
                material {T_3}
                        //finish {emission 1 diffuse 1}
                }
        }
        /*light_source {
                <0,0, 0>
                color rgb 1
                spotlight
                radius 30
                falloff 32
                tightness 1
                point_at <0,0, -100>
        }*/
}

 //spotlight 2
#declare spotlamp2 = 
union {
        difference {
                cone {<0,0,0.5>, 0, <0,0,-0.5>, 1}
                cone {<0,0,0.45>, 0, <0,0,-0.5>, 0.9 open 
                material {T_3}
                        //finish {emission 1 diffuse 1}
                }
        }
        /*light_source {
                <0,0, 0>
                color rgb 1
                spotlight
                radius 15
                falloff 17
                tightness 1
                point_at <0,0, -100>
        }*/
}

// dish antenna
#declare dish1 = 
union {
        difference {
                sphere{<0,0,-12>, 12}
                sphere{<0,0,-13>, 12.5}
        }
        cylinder {<0,0,-14>, <7, 7,-5.5>, 0.3}
        cylinder {<0,0,-14>, <-7, 7,-5.5>, 0.3}    
        cylinder {<0,0,-14>, <7, -7,-5.5>, 0.3}
        cylinder {<0,0,-14>, <-7,-7,-5.5>, 0.3}
        cone {<0,0,-18>, 0, <0,0,-12>, 1}
}

// sensor thingy 1
#declare sensething1 = 
union {  
        torus {4, 0.2 scale 2*x translate 3.9*y}
        torus {3.4, 0.2 scale 1.8*x translate 2.9*y}
        torus {2.8, 0.2 scale 1.6*x translate 2.1*y}
        torus {2.2, 0.2 scale 1.4*x translate 1.5*y}
        torus {1.6, 0.2 scale 1.2*x translate 1.2*y}
        sphere {<0,1,0>, 1}
        cylinder {<0,-1,0>, <0,4,4.4>, 0.2}
        cylinder {<0,-1,0>, <0,4,-4.4>, 0.2}
        cylinder {<0,-1,0>, <8.8,4,0>, 0.2}
        cylinder {<0,-1,0>, <-8.8,4,0>, 0.2}
        cylinder {<0,-1,0>, <0,2,-10 >, 0.5}
        cylinder {<0,-1,0>, <4,-3,-10 >, 0.3}    
        cylinder {<0,-1,0>, <-4,-3,-10 >, 0.3}         
        rotate -90*x        
        translate 9.9*y
}                

#declare treadloop = 
union { 
        torus { 2.125,0.5 rotate  120*x translate <5,0, 0>}
        torus { 2.125,0.5 rotate -120*x translate <5,0, 0>}
        torus { 2.125,0.5 rotate   90*x translate <5,0, 0> rotate 15*y}
}

#declare treadhalf = 
union {
        object {treadloop}
        object {treadloop rotate  30*y}
        object {treadloop rotate  60*y}
        object {treadloop rotate  90*y}
        object {treadloop rotate 120*y}
        object {treadloop rotate 150*y}
        object {treadloop rotate 180*y}
}

#declare basicwheel = 
union {
        object {treadhalf}
        object {treadhalf rotate 180*y}
        object {treadhalf rotate 180*x}
        object {treadhalf rotate 180*y rotate 180*x}
        torus  {5, 2} // tyre
}

#declare tyre1 = 
union {
        difference {
                object {basicwheel}
                cone {<0, 1.5,0>, 5 <0, 3,0>, 9} 
                cone {<0,-1.5,0>, 5 <0,-3,0>, 9} 
        }
}

#declare chunkywheel = 
union {
        object {tyre1 rotate 90*z material {T_2}}
        // hub
        cylinder {<0,2,0>, <0,-2,0>, 4 rotate 90*z}
        sphere {<0,0,0>, 4 scale 0.8*x}
}

// sitting bloke 
#declare sitbloke = 
union {    
        blob {
                threshold 0.5
                //body
                sphere {<0,0, 0>, 5 ,1 scale <.7, 1.2,0.25> rotate 30*x translate <0,0,3> MetalMat (<1,1,1>*0.5)}
                sphere {<0,0, 0>, 4 ,1 scale <1 ,0.5,0.3 > translate <0,2,4> MetalMat (<1,1,1>*0.5)}
                // legs         
                sphere {<0,0,-2>, 3 ,1 translate <2.5,-4,2> scale <0.5,0.5,1.5> MetalMat (<1,1,1>*0.5)}
                sphere {<0,0,-2>, 3 ,1 translate <-2.5,-4,2> scale <0.5,0.5,1.5> MetalMat (<1,1,1>*0.5)}
                sphere {<0,0, 0>, 3 ,1 translate <2.3,-3,-7> scale <0.4,1.5,0.3> MetalMat (<1,1,1>*0.5)}
                sphere {<0,0, 0>, 3 ,1 translate <-2.3,-3,-7> scale <0.4,1.5,0.3> MetalMat (<1,1,1>*0.5)}
                // head         
                sphere {<0,0, 0>, 2.5, 1 scale <0.7,1,0.7> translate <0,5,4> MetalMat (<1,0.75,0.5>)} 
                // arms         
                sphere {<0,0,-2>, 3 ,1 translate <6,7,3.5> scale <0.35,0.35,1.25> MetalMat (<1,1,1>*0.5)}
                sphere {<0,0,-2>, 3 ,1 translate <-6,7,3.5> scale <0.35,0.35,1.25> MetalMat (<1,1,1>*0.5)}
                sphere {<0,0,-2>, 3 ,1 translate <8,9,0.5> scale <0.25,0.25,0.9> MetalMat (<1,1,1>*0.5)}
                sphere {<0,0,-2>, 3 ,1 translate <-8,9,0.5> scale <0.25,0.25,0.9> MetalMat (<1,1,1>*0.5)}
        }  
        // hat
        #declare tophat = 
        union {
                cylinder {<0,0, 0>, <0,0.001, 0>, 1.6 MetalMat (<1,1,1>*0.25)}
                cylinder {<0,0, 0>, <0,1.8 ,0>, 0.9 MetalMat (<1,1,1>*0.25)}
        }
        object {tophat translate <0,5.5,4>}
}
// end sitting bloke -----------------------

//  MAIN spherical cage
#declare cage = 
union {
    torus {10, 0.3}
    torus {10, 0.3 rotate  90*x}
    torus {10, 0.3 rotate  90*z}
    torus {10, 0.2 rotate  45*z}
    torus {10, 0.2 rotate -45*z}
    
    torus {9.5, 0.2 translate  3*y}
    torus {8  , 0.2 translate  6*y}
    torus {5.4, 0.2 translate  8.5*y}
    torus {9.5, 0.2 translate -3*y}
    torus {8  , 0.2 translate -6*y}
    torus {5.4, 0.2 translate -8.5*y}
    // seat etc
    box {<-2,-5,-1>, <2,-2,4> material {T_6}}
    box {<-4,-7,-5>, <4,-5,5> material {T_6}}
    box {<-3,-4,4>, <3,5,5> material {T_6}}
    // controls
    cone {<0,-1,-10>, 1, <0,1,-2>, 2 material {T_2}}
    /*light_source {<0,0,0>, color rgb <0.75,0,0>
    //    fade_distance 15
    //    fade_power 1.5
    }*/
}
//  end main cage

//  MAIN spherical cage dull version
#declare cagedull = 
union {
        torus {10, 0.3}
        torus {10, 0.3 rotate 90*x}
        torus {10, 0.3 rotate 90*z}
        
        torus {10, 0.2 rotate  45*z}
        torus {10, 0.2 rotate -45*z}
        
        
        torus {9.5, 0.2 translate  3*y}
        torus {8  , 0.2 translate  6*y}
        torus {5.4, 0.2 translate  8.5*y}
        torus {9.5, 0.2 translate -3*y}
        torus {8  , 0.2 translate -6*y}
        torus {5.4, 0.2 translate -8.5*y}
        // seat etc
        box {<-2,-5,-1>, <2,-2,4> material {T_6}}
        box {<-4,-7,-5>, <4,-5,5> material {T_6}}
        box {<-3,-4,4>, <3,5,5> material {T_6}}
        // controls
        cone {<0,-1,-10>, 1, <0,1,-2>, 2 MetalMat (<1,1,1>*0.1)}
}

//  end main cage dull

//*******************************gun barrell 
#declare gunbarrel1 = 
union {
        cylinder {<0,0,4>, <0,0,-4>, 0.6}
        cylinder {<0,0,-4>, <0,0,-8>, 0.3}
        cone {<0,0,-8> , 0.3, <0,0,-10>, 0.8}
        object {boxsect2 scale 0.25 }
        object {boxsect2 scale 0.25  translate -2*z}
        object {boxsect2 scale 0.2   translate -4*z}
        object {boxsect2 scale 0.125 translate -5*z}
        object {boxsect2 scale 0.125 translate -6*z}
        object {boxsect2 scale 0.125 translate -7*z}
        object {boxsect2 scale 0.125 translate -8*z}
        MetalMat (<1,0.75,0>)
}
//// end gunbarrel

// /////////////////////////////////// MAIN INSTANTIATIONS

// turret ball--------------------------------------------
#declare turretball = 
union {
        object {cage}
        sphere {
                <0,0,0>, 9
                pigment {color rgb 1 filter 1}
                finish {
                        ambient 0
                        diffuse 0
                        reflection 0.25
                        specular 1
                        roughness 0.001
                }
                //   interior {ior 1.01}
        }
        // gunner
        object {sitbloke scale 0.75}
        // gun mount
        object {
                boxsect2
                material {T_6}
                translate -12*z
                scale 0.75
        }
        // Gunbarrels
        object {gunbarrel1 scale 1.2 translate <0,0,-10>}        
        object {gunbarrel1 translate <3,3,-8>}
        object {gunbarrel1 translate <-3,-3,-8>}
        object {gunbarrel1 translate <3,-3,-8>}
        object {gunbarrel1 translate <-3,3,-8>}
}
// END  turret ball-------------------

// turret ball minus guns--------------------------------------------
#declare turretballminus = 
union {
    object {cage}
    sphere {<0,0,0>, 9
       pigment { rgb 1 filter 1 }
       finish {
          ambient 0
          diffuse 0
          reflection .25
          specular 1
          roughness .001
       }
    //   interior { ior 1.01 }
    }
    // gunner
    object {sitbloke scale .75}
}

// turret ball minus guns no lights--------------------------------------------
#declare turretballminusdull = 
union {
    object {cagedull}
    sphere {
       <0,0,0>, 9
       pigment { rgb 1 filter 1 }
       finish {
          ambient 0
          diffuse 0
          reflection .25
          specular 1
          roughness .001
       }
    //   interior { ior 1.01 }
    }
    // gunner
    object {sitbloke scale .75}
}

// ballmount -------------------------
//ball mount
#declare ballmount = 
union {
    difference {
        sphere { 0,11 }
        sphere { 0,10.5 }                
        box {<-12, -12, -12>, <12,12,6>}
    }
    //  LAMPS
    object {spotlamp rotate 20*y translate <12,0, 15>}
    object {spotlamp rotate -20*y translate <-12,0, 15>} 
    object {spotlamp rotate -20*x translate <0, 12, 15>}
    object {spotlamp rotate 20*x translate <0, -12, 15>}
    cylinder {<11, 0, 15>, <-11,0, 15> 0.2 }
    cylinder {<0, -11, 15>, <0, 11, 15> 0.2 }
    cylinder {<0, 0,8>, <0,0, 14> 5 }
    sphere {<0,0, 18> 6 }
}
// ballmount minus lights -------------------------

#declare ballmountminus = 
union {
    difference {
        sphere { 0,11 }
        sphere { 0,10.5 }                
        box {<-12, -12, -12>, <12,12,6>}
    }
    cylinder {<0,0,8>, <0,0, 14> 5 }
    sphere {<0,0, 18> 6 }
}
  
//  ************ rocket **************** 
#declare rocket = 
union {
    cylinder {<0,0 ,15>, <0 ,0 ,-15> 1   material {T_4}}
    cylinder {<0,1.5, 15>, <0 ,1.5, -15>  .5 material {T_4}}
    cylinder {<0 ,-1.5, 15>, <0  ,-1.5, -15>  .5 material {T_4}}
    cylinder {<1.5,0 ,15>, <1.5, 0 ,-15>  .5 material {T_4}}
    cylinder {<-1.5,0 ,15>, <-1.5, 0 ,-15>  .5 material {T_4}}
    sphere {<0,0, -12.5>, 2.5 material {T_1}}
    sphere {<0,0, -16>, 2 material {T_1}}    
    box {<.1, -4, -4>, <.1, 3,3> rotate 45*x scale <1,0.8, 1> translate -10*z material {T_2}}
    box {<.1, -4, -4>, <.1, 3,3> rotate 45*x scale <1,0.8, 1> rotate 90*z translate -10*z material {T_2}}
    box {<.1, -6, -6>, <.1, 5,5> rotate 45*x scale <1,0.8, 1> translate  10*z material {T_2}}
    box {<.1, -5, -5>, <.1, 5,5> rotate 45*x scale <1,0.8, 1> rotate 90*z translate  10*z material {T_2}}    
    lathe { 7 
        <0, 5>, <.5, 4>, <1, 2>, <1.8, 1> <2, 0>, <0,-2>, <0,5>
        material {T_4}
        rotate -90*x
        translate -18*z    
    }
    sphere {<0,0, 10>, 2.5 material {T_1}}
    sphere {<0,0, 13>, 3   material {T_1}}
    cone {<0,0, 15>, 1, <0,0, 18>, 3 open material {T_1}}
    scale 1.5*z
}
    
// big rocket turret ***************************************************
#declare rocketbase = 
union {
    difference {
        lathe {
            9
            <0, 20>, <20, 20>, <30, 15>, <35, 10>, <30, 2>, <25, 2>, <25, 0>, <0, 0>, <0, 20>}
        sphere {<0,20, -20>, 11 }
        cylinder {<12, 40, 0>, <40, 40, 0> 36 }
        cylinder {<-12, 40, 0>, <-40, 40, 0> 36 }
    }    
    // control room    
    object {turretballminus rotate 20*x translate <0, 20, -20> material {T_4}}
    object {ballmount translate <0, 20, -20> material {T_4}}
    //weapon mount
    cylinder {<10, 10, 20>, <5, 40,0> 1 }
    cylinder {<-10, 10, 20>, <-5, 40,0> 1 }
    cylinder {<10, 10,-20>, <5, 40,0> 1 }
    cylinder {<-10, 10,-20>, <-5, 40,0> 1 }
    cylinder {<35, 40,0>, <-35, 40,0> 2 }
    
    #declare toraldisk = 
    union {
        torus { 15, 1 rotate 90*z translate <0, 40,0>}
        difference {
            cylinder {<-1, 40,0>, <1, 40,0> 12 }
            cylinder {<-2, 45,5>, <2, 45,5>  4 }
            cylinder {<-2, 45, -5>, <2, 45, -5>  4 }
            cylinder {<-2, 35,5>, <2, 35,5>  4 }
            cylinder {<-2, 35, -5>, <2, 35, -5>  4 }
        }
    }
    object {toraldisk translate  15*x}
    object {toraldisk translate -15*x}
}


// rocket cluster
#declare cluster = 
union {
    object {boxsect2 scale 1.5 translate <0,0,0> material {T_6}}
    object {boxsect2 scale 1.5 rotate 45*z translate <0,0,0> material {T_6}}
    object {rocket translate <9.5,0,0>}
    object {rocket translate <9.5,0,0> rotate  45*z}
    object {rocket translate <9.5,0,0> rotate  90*z}
    object {rocket translate <9.5,0,0> rotate 135*z}
    object {rocket translate <9.5,0,0> rotate 180*z}
    object {rocket translate <9.5,0,0> rotate 225*z}
    object {rocket translate <9.5,0,0> rotate 270*z}
    object {rocket translate <9.5,0,0> rotate 315*z}
}


// rocket turret
#declare rocketturret = 
union {
    object {rocketbase}
    object {cluster rotate 25*x translate <30, 40, 0>}
    object {cluster rotate 25*x translate <-30, 40, 0>  }
    object {dish1 scale 1.25 rotate 25*x translate <0, 55, 0>}
    cylinder {<-15, 55,0.5>, <15, 55,0.5> 1 }
}


#declare quarttor = 
union {
    difference {
        torus {4, 1}
        box {<-6, -2,0>, <6,2,6>}
        box {<0, -2,6>, <6,2, -6>}
    rotate -90*z
    }
}

///  BULLBARS -------------------------------------

#declare halftor = 
union {
    difference {
        torus { 4, 1}
        box {<-6, -2,0>, <6,2, -6>}
    }
}

#declare bullsect = 
union {
    object {quarttor translate <-4, 4, -12>}
    object {quarttor rotate -90*x translate <-4, -4, -12>}
    object {quarttor translate <4, 4, -12>}
    object {quarttor rotate -90*x translate <4, -4, -12>}
    object {halftor translate <0, 8, -12>}
    object {halftor translate <0, -8, -12>}
    cylinder {<-4, -4, -16>, <-4, 4, -16> 1 }
    cylinder {<4, -4, -16>, <4, 4, -16> 1 }
}            

#declare bullbars = 
union {
    object {bullsect}
    object {bullsect translate  16*x}
    object {bullsect translate -16*x}
    cylinder {<20,4, -15>, <-20,4, -15> 1 }
    cylinder {<20, -4, -15>, <-20, -4, -15> 1 }
    object {quarttor rotate -90*z translate <20,4, -11>}
    object {quarttor rotate -90*z translate <20, -4, -11>}
    object {halftor  rotate  90*z translate <24,0, -11>}
    object {quarttor rotate  90*z translate <-20,4, -11>}
    object {quarttor rotate  90*z translate <-20, -4, -11>}
    object {halftor  rotate  90*z translate <-24,0, -11>}
}

///  END BULLBARS -------------------------------------

#declare spikequart2 = 
union {
    cone {<0,0, 0>, 3 <0, 15, 0>, 0 }
    cone {<0,0, 0>, 3 <0, 15, 0>, 0 rotate 30*x}
    cone {<0,0, 0>, 3 <0, 15, 0>, 0 rotate 60*x}
    cone {<0,0, 0>, 3 <0, 15, 0>, 0 rotate 90*x}
}

#declare spikecyl = 
union {
    cylinder {<-1,0,0>, <1,0,0> 10 }
    object {spikequart2}
    object {spikequart2 rotate  90*x}
    object {spikequart2 rotate 180*x}
    object {spikequart2 rotate 270*x}
}

#declare bogie1 = 
union {
    cylinder {<-5,0,0>, <5,0,0> 8 }
    difference { 
        object {spikecyl}
        cone {<4,0, 0>, 7 <-1  0, 0>, 4 }
        translate 6*x
    }
    difference {
        object {spikecyl}
        cone {<-4,0, 0>, 7 <-1  0, 0>, 4 }
        translate -6*x
    }
}

#declare basewheel = 
union {
    cylinder {<-5,0,0>, <5,0,0> 6 }
    cylinder {<-5,0,0>, <-7,0,0> 8 }
    cylinder {<5,0,0>, <7,0,0> 8 }
}


#declare bogie2 = 
union {
    difference {    
        object {basewheel}
        cone {<8,0, 0>, 6 <2,0,0>, 4 }
        cone {<-8,0, 0>, 6 <-2,0,0>, 4 }
    }
}

#declare tracklink = 
union {
    box {<-5, -1, -5> <5,1,5>}
    cylinder {<-8,0, -3> <8,0, -3> 1.5 }
    cone {  0, 2 9*y, 0 }
    cone {<7,0, -3>, 1.5 <12,5, -3>, 0 }
    cone {<-7,0, -3>, 1.5 <-12,5, -3>, 0 }
}

// main track element **************************
#declare trax = 
union {
    object {bogie1 translate <0,10, -35>}
    object {bogie1 translate <0,10,  0>}
    object {bogie1 translate <0,10, 35>}
    object {bogie1 translate <0,30, -60>}
    object {bogie1 translate <0,30, 60>}
    object {bogie2 translate <0,31, 18>}
    object {bogie2 translate <0,31, -18>}
    object {tracklink translate <0,41, - 54> material {T_2}}
    object {tracklink translate <0,41, - 48> material {T_2}}
    object {tracklink translate <0,41, - 42> material {T_2}}
    object {tracklink translate <0,41, - 36> material {T_2}}
    object {tracklink translate <0,41, - 30> material {T_2}}
    object {tracklink translate <0,41, - 24> material {T_2}}
    object {tracklink translate <0,41, - 18> material {T_2}}
    object {tracklink translate <0,41, - 12> material {T_2}}
    object {tracklink translate <0,41, - 6> material {T_2}}
    object {tracklink translate <0,41, - 0> material {T_2}}
    object {tracklink translate <0,41,  6> material {T_2}}
    object {tracklink translate <0,41, 12> material {T_2}}
    object {tracklink translate <0,41, 18> material {T_2}}
    object {tracklink translate <0,41, 24> material {T_2}}
    object {tracklink translate <0,41, 30> material {T_2}}
    object {tracklink translate <0,41, 36> material {T_2}}
    object {tracklink translate <0,41, 42> material {T_2}}
    object {tracklink translate <0,41, 48> material {T_2}}
    object {tracklink translate <0,41, 54> material {T_2}}
    object {tracklink translate <0,41, 60> material {T_2}} 
    // front wheel track curve
    object {tracklink translate <0,41,  - 61> material {T_2}}
    object {tracklink rotate  -30*x translate <0, 39 ,-66> material {T_2}}
    object {tracklink rotate  -70*x translate <0, 35.5, -70> material {T_2}}
    object {tracklink rotate -110*x translate <0, 29.5, -72> material {T_2}}
    object {tracklink rotate -130*x translate <0, 24 ,-69> material {T_2}}
    object {tracklink rotate -135*x translate <0, 20 ,-65> material {T_2}}
    object {tracklink rotate -135*x translate <0, 16 ,-61> material {T_2}}
    object {tracklink rotate -135*x translate <0, 12 ,-56> material {T_2}}
    object {tracklink rotate -135*x translate <0,8 ,-51> material {T_2}}
    object {tracklink rotate -135*x translate <0,4 ,-46> material {T_2}}
    object {tracklink rotate -155*x translate <0,0 ,-40> material {T_2}}
    // bottom track
    object {tracklink rotate -180*x translate <0, -1, -34> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1, -28> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1, -22> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1, -16> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1, -10> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1, -4> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1, 2> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1, 8> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1,14> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1,18> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1,24> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1,30> material {T_2}}
    object {tracklink rotate -180*x translate <0, -1,36> material {T_2}}

    object {tracklink translate <0,41,   61> material {T_2}}
    object {tracklink rotate  30*x translate <0,39,66> material {T_2}}
    object {tracklink rotate  70*x translate <0,35.5,70> material {T_2}}
    object {tracklink rotate 110*x translate <0,29.5,72> material {T_2}}
    object {tracklink rotate 130*x translate <0,24,69> material {T_2}}
    object {tracklink rotate 135*x translate <0,20,65> material {T_2}}
    object {tracklink rotate 135*x translate <0,16,61> material {T_2}}
    object {tracklink rotate 135*x translate <0,12,56> material {T_2}}
    object {tracklink rotate 135*x translate <0, 8,51> material {T_2}}
    object {tracklink rotate 135*x translate <0, 4,46> material {T_2}}
    object {tracklink rotate 155*x translate <0, 0,40> material {T_2}}
    difference {
        sphere {<0,40,0>, 25 scale <1,1, 2>}
        box {<-12,0, -60> <12,55, 60>}
        cylinder {<15,45,0> <25,45,0> 15 }
        cylinder {<-15,45,0> <-25,45,0> 15 }
        cylinder {<18,45,0> <25,45,0> 18 }
        cylinder {<-18,45,0> <-25,45,0> 18 }
        cylinder {<20,45,0> <25,45,0> 24 }
        cylinder {<-20,45,0> <-25,45,0> 24 }

        cylinder {<15,50,0> <25,50,0> 15 }
        cylinder {<-15,50,0> <-25,50,0> 15 }
        cylinder {<18,50,0> <25,50,0> 18 }
        cylinder {<-18,50,0> <-25,50,0> 18 }
        cylinder {<20,50,0> <25,50,0> 24 }
        cylinder {<-20,50,0> <-25,50,0> 24 }
    }
    torus { 20, 2 scale 0.7*x rotate -45*x translate <0,43, -46>}
    torus { 20, 2 scale 0.8*x scale 1.5*z rotate -40*x translate <0,47.5, -37>}
    torus { 20, 2 scale 0.7*x rotate 45*x translate <0,43, 46>}
    torus { 20, 2 scale 0.8*x scale 1.5*z rotate  40*x translate <0,47.5,37>}
    cylinder {<15,45,0> <25,45,0> 10 }
    cylinder {<-15,45,0> <-25,45,0> 10 }
    cylinder {<-25,70,0> <25,70,0>  4 }
    cylinder {<21,73,0> <21,42,7>  3 }
    cylinder {<21,73,0> <21,42, -7>  3 }
    cylinder {<-21,73,0> <-21,42,7>  3 }
    cylinder {<-21,73,0> <-21,42, -7>  3 }
    translate -110*y
}
// END     main track element **************************


// cutter section -------------------
#declare cuttersect = 
union {
    object {spikequart2 scale 1.2 rotate 90*y material {T_6}}
    object {spikequart2 rotate 90*y translate -4*z material {T_6}}
}

// single cutter element -------------------
#declare cutter = union {
    cone {<0,0,0>, 10 <0,0, -7>, 5 }
    object {cuttersect}
    object {cuttersect rotate  90*z}
    object {cuttersect rotate 180*z}
    object {cuttersect rotate 270*z}
    object {spikequart2 scale 0.8 rotate -135*x translate -3*z material {T_6}}
    object {spikequart2 scale 0.8 rotate -135*x rotate  60*z translate -3*z material {T_6}}
    object {spikequart2 scale 0.8 rotate -135*x rotate -60*z translate -3*z material {T_6}}
    cylinder {<0,0,0> <0,0,8> 3 }
}

// big cutter element  ******************
#declare bigcutter = 
union {
    object {cutter rotate  30*y translate <20, 0,0>}
    object {cutter rotate -30*y translate <-20, 0,0>}
    object {cutter rotate -30*x translate <0,20,0>}
    object {cutter rotate  30*x translate <0, -20,0>}
    cone {<0,0, 15>, 2 <0,0, 5>, 27 open }
    cone {<0,0, 16>, 2 <0,0, 6>, 27 open }
    sphere {<0,0, 20>, 8 }
}

#declare mutherdriller = 
union {

    object {bigcutter rotate 20*z rotate 40*y translate 45*x}
    object {bigcutter rotate 45*z rotate -40*y translate -45*x}
    object {bigcutter rotate 30*z rotate -40*x translate 45*y}
    object {bigcutter rotate 75*z rotate 40*x translate -45*y}
    cylinder {<60, 0,18> <0,0,40> 6 }
    cylinder {<-60, 0,18> <0,0,40> 6 }
    cylinder {<0,60,18> <0,0,40> 6 }
    cylinder {<0, -60,18> <0,0,40> 6 }      
    object {bigcutter rotate -90*y translate <70,0, 5> rotate  45*z}
    object {bigcutter rotate -90*y translate <70,0, 5> rotate 135*z}
    object {bigcutter rotate -90*y translate <70,0, 5> rotate 225*z}
    object {bigcutter rotate -90*y translate <70,0, 5> rotate 315*z}
        
    cylinder {<35,35,10> <0,0,40> 6 }
    cylinder {<-35, -35,10> <0,0,40> 6 }
    cylinder {<-35,35,10> <0,0,40> 6 }
    cylinder {<35, -35,10> <0,0,40> 6 }
    
    object {bigcutter translate <0,0, 0> rotate 0*z}
}

// end ----- muther driller --------------------

// boxsection 1 **************************
#declare boxsect1 = 
union { 
    object {crossbeam}    
    object {crossbeam translate  4*y}
    object {crossbeam translate -4*y}
    object {crossbeam translate -4*y rotate 90*x} 
    object {crossbeam translate  4*y rotate 90*x}  
    object {crossbeam translate  4*y rotate 90*y rotate 90*z}
    object {crossbeam translate -4*y rotate 90*y rotate 90*z}  
}

// ***** Point Defence Gun 1 **************
#declare pointdef1 = 
union {    
    difference {    
        sphere {<0,0,0>, 3.5 }     
        box {<-4, -4, -4>, <4,0,4>}
    }
    box {<-4, 3, 0>, <4,2,2>}
    cylinder {<0,0,0>, <1,4 ,-6>, 0.3 }
    cylinder {<0,0,0>, <-1,4 ,-6>, 0.3 }
    cylinder {<0,0,0>, <1,5.5, -5>, 0.3 }
    cylinder {<0,0,0>, <-1,5.5, -5>, 0.3 }
}
// END Point Defence Gun 1 **************

// ***** Point Medium Gun 1 **************
#declare medgun1 = 
union {    
    difference {    
        sphere {<0,0,0>, 3.5 }     
        box {<-4, -4, -4>, <4,0,4>}
    }
         
    box {<-4, 3, 0>, <4,2,2>}
    cylinder {<0,0,0>, <1,4, -6>, 0.5 }
    cylinder {<0,0,0>, <-1,4, -6>, 0.5}
}
// END Point Medium Gun 1 **************



// engine type 1 **************************
#declare engine01 = 
union { 
    // BOILER ----------------------
    sphere {<0,0, 0>, 12 }
    sphere {<0, 10, 0>, 8 }
    // main struts-----------------------------
    cylinder {<4,16, 4>, <12, -6, 12>, 1} 
    cylinder {<-4,16, 4>, <-12, -6, 12>, 1} 
    cylinder {<4,16, -4>, <12, -6, -12>, 1} 
    cylinder {<-4,16, -4>, <-12, -6, -12>, 1} 
    // strut ends-----------------------------
    sphere {<4,16, 4>, 2 } 
    sphere {<-4,16, 4>, 2 } 
    sphere {<4,16, -4>, 2 } 
    sphere {<-4,16, -4>, 2 }
    // Thruster Mounts ------------------------
    cylinder {<0, 10, 0>, <16, -8,0>, 2 }  
    cylinder {<0, 10, 0>, <0, -8, 16>, 2 }
    cylinder {<0, 10, 0>, <-16, -8,0>, 2 }
    cylinder {<0, 10, 0>, <0, -8,-16>, 2 }
    // thrusters --------------------------------
    cone {<16, -4,0>, 0.5 <16, -12,0>, 4 open }
    cone {<-16, -4,0>, 0.5 <-16, -12,0>, 4 open }
    cone {<0, -4, 16>, 0.5 <0, -12, 16>, 4 open }
    cone {<0, -4,-16>, 0.5 <0, -12,-16>, 4 open }

    //and their struts ------------------------------------
    cylinder {<4,18,4>, <16, -4,0>, 0.5 } 
    cylinder {<4,18, -4>, <16, -4,0>, 0.5 }  
    cylinder {<-4,18,4>, <-16, -4,0>, 0.5 } 
    cylinder {<-4,18, -4>, <-16, -4,0>, 0.5 }
    cylinder {<4,18,4>, <0, -4, 16>, 0.5 }
    cylinder {<-4,18,4>, <0, -4, 16>, 0.5 }
    cylinder {<4,18, -4>, <0, -4,-16>, 0.5 }
    cylinder {<-4,18, -4>, <0, -4,-16>, 0.5 } 

    // Main Drive 
    lathe {
        cubic_spline
        10,
        <0,0>,<5,-5> <10,-10>, <10,-12>, <12,-16>, <12,-16>, <10,-12>,<10,-10>, <5,-5>, <0,0>
    } 
    
    //Engine torus
    torus { 17, 1 translate <0, -6, 0>}
    translate -16*y
    rotate -90*x 
 }
 // END OF ENGINE 1 ***********************************************************


#declare broom = 
union {
    lathe {
        linear_spline 
        8,
        <0,3>,<4,2.5> <5,2>, <6,1>, <6,-1>, <5,-2>, <0, -2>, <0,3>
    }
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate  15*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate  45*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate  75*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate 115*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate 145*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate 175*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate 205*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate 235*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate 265*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate 295*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate 315*y}
    torus { 2.2,0.15 scale 1.3*z rotate 90*z translate -5*z rotate 345*y}

    torus { 7.5,0.15 translate  1*y}
    torus { 7.5,0.15 translate -1*y}
}
// end broom

// simple bridge room - GOTH *************
#declare bridge_room = 
union {
    difference {
        object {broom}
        object {broom scale <0.92, 0.8, 0.92> material {T_3}}
        box {<-2,0.5, -6>, <2,1.5,0> material {T_3}}
        box {<-2,0.5, -6>, <2,1.5,0> rotate -50*y material {T_3}}
        box {<-2,0.5, -6>, <2,1.5,0> rotate  50*y material {T_3}}
    }
    /*light_source {<2, 1, -4> Blue 
        fade_distance 15
        fade_power 1.5
    }
    light_source {<-2, 1, -4> Blue 
        fade_distance 15
        fade_power 1.5
    }
    */
    cylinder {<-12 ,0, 0>, <12 ,0, 0>, 1}
    box {<-10 ,0, 4>, <10,2, 0>}
} 
// END  simple bridge room - GOTH *************



#declare windoze = 
union {
    cylinder {<0, 0, -7>, <0, 0,7>, 0.5 scale 4*x}
    cylinder {<0 ,0, -7>, <0 ,0,7>, 0.5 scale 2*x rotate  35*y}
    cylinder {<0 ,0, -7>, <0 ,0,7>, 0.5 scale 2*x rotate  60*y}
    cylinder {<0 ,0, -7>, <0 ,0,7>, 0.5 scale 2*x rotate  90*y}
    cylinder {<0 ,0, -7>, <0 ,0,7>, 0.5 scale 2*x rotate 120*y}
    cylinder {<0 ,0, -7>, <0 ,0,7>, 0.5 scale 2*x rotate 145*y}
}




// bridge room with lights
#declare bridge_room2 = 
union {
    difference {
        object {broom}    
        object {windoze}
        object {windoze scale 0.5*y translate 1.5*y}
        lathe {
            linear_spline
            8,
            <0,3>,<4,2.5> <5,2>, <6,1>, <6,-1>, <5,-2>, <0, -2>,<0,3> 
            scale 0.95
            translate 0.1*y
            material {T_2}
        }
    }
    /*light_source {
        <2,1,-3>, color rgb <0.7,0.8,1> 
        fade_distance 15
        fade_power 1.5
    }
    light_source { 
        <-2,1,-3>, color rgb <0.7,0.8,1> 
        fade_distance 15
        fade_power 1.5
    }
    */
}
// end bridge room with lights

// london bridge module **********************
#declare lonbridge = 
union {
    cylinder {<0,0, -80>, <0, 70, -50> 1.5 }
    cylinder {<8, 45, -40>, <0,70, -50> 1 }
    cylinder {<-8, 45, -40>, <0,70, -50> 1 }
    torus { 12 ,.75 scale 1.5*x rotate 90*x rotate  15*y translate <0,55, -50>}
    torus { 12 ,.75 scale 1.5*x rotate 90*x rotate -15*y translate <0,55, -50>}
    object {bridge_room2 scale 2.2 translate <0,75, -47>}
    object {bridge_room2 scale 1.5 translate <15,55, -60>}
    object {bridge_room2 scale 1.5 translate <-15,55, -60>}
} 

// end lonbridge ++++++++++++++++++

//spotlight 3
#declare spotlamp3 = 
union {
        difference {
                cone {<0,0,0.5>,0, <0,0,-0.5>, 1}
                cone {<0,0,0.45>,0, <0,0,-0.5>, 0.9 open 
                pigment {color rgb y} finish {emission 1 diffuse 1}}
        }
}

// ========= laser cannon
#declare lasercannon = 
union {
        cylinder {<0,0,-7>, <0,0,7>, 0.5}
        sphere {<0,0,5>, 4 scale <0.2,0.3,1> material {T_1}}
        sphere {<0,0,2>, 4 scale <0.3,0.3,1>}
        difference {
                sphere {<0,0,-8>, 4 scale <0.22,0.22,1>}
                sphere {<0,0,-10>, 4 scale <0.25,0.25,1> material {T_5}}
        }
        cone {<0,0, -11>,0.2, <0,0, -15>,0.05}
        cylinder {<0,0, -14>, <1,0, -8>, 0.05}
        cylinder {<0,0, -14>, <-1,0, -8>, 0.05}
        cylinder {<0,0, -14>, <0,1, -8>, 0.05}
        cylinder {<0,0, -14>, <0, -1, -8>, 0.05}
        cylinder {<1,0, 4>, <1,0, -8>, 0.1}
        cylinder {<-1,0, 4>, <-1,0, -8>, 0.1}
        cylinder {<0,1, 4>, <0,1, -8>, 0.1}
        cylinder {<0, -1, 4>, <0, -1, -8>, 0.1}   
        object {spotlamp3 scale 0.7 translate <0,0,-7>}
}

// END  ========= laser cannon

// ========= laser cannon DULL
#declare lasercannondull = 
union {
        cylinder {<0,0,-7>, <0,0,7>, 0.5}
        sphere {<0,0, 5>, 4 scale <0.2,0.3,1> material {T_1}}
        sphere {<0,0, 2>, 4 scale <0.3,0.3,1>}
        difference {
                sphere {<0,0,-8>, 4 scale <0.22,0.22,1>}
                sphere {<0,0,-10>, 4 scale <0.25,0.25,1>  material {T_5}}
        }
        cone {<0,0,-11>, 0.2, <0,0,-15>, 0.05}
        cylinder {<0,0,-14>, <1,0,-8>, 0.05}
        cylinder {<0,0,-14>, <-1,0,-8>, 0.05}
        cylinder {<0,0,-14>, <0,1,-8>, 0.05}
        cylinder {<0,0,-14>, <0,-1,-8>, 0.05}
        cylinder {<1,0,4>, <1,0,-8>, 0.1}
        cylinder {<-1,0,4>, <-1,0,-8>, 0.1}
        cylinder {<0,1,4>, <0,1,-8>, 0.1}
        cylinder {<0,-1,4>, <0,-1,-8>, 0.1}
}

// END  ========= laser cannon     DULL

// ========= laser cannon   minus pointy bit
#declare lasercannonminus = 
union {
        cylinder {<0,0,-7>, <0,0,7>, 0.5}
        sphere {<0,0, 5>, 4 scale <0.2,0.3,1> material {T_1}}
        sphere {<0,0, 2>, 4 scale <0.3,0.3,1>}
        difference {
                sphere {<0,0,-8>, 4 scale <0.22,0.22,1>}
                sphere {<0,0,-10>, 4 scale <0.25,0.25,1> material {T_5}}
        }
        cylinder {<1,0,4>, <1,0,-8>, 0.1}
        cylinder {<-1,0,4>, <-1,0,-8>, 0.1}
        cylinder {<0,1,4>, <0,1,-8>, 0.1}
        cylinder {<0,-1,4>, <0,-1,-8>, 0.1}      
        object {spotlamp3 scale 0.7 translate <0,0,-7>}

}

// END  ========= laser cannon minus pointy bit

#declare biggun02 = 
union {
        difference {
                sphere {0, 8 scale 0.4*y}
                sphere {<0,3,-2.5> 2.5}
                cylinder {<0,-1,0>, <0,-10,0>, 9}
        }
        torus {8, 0.6 translate 1.3*y}
        object {turretballminus scale 0.25 translate <0,3,-2.5>}
        cone {<0,0,0>, 4, <0,-6,0>, 6}
        object {lasercannon rotate 25*x translate <5,7,0>}
        object {lasercannon rotate 25*x translate <5,10,0>}
        object {lasercannon rotate 25*x translate <-5,7,0>}
        object {lasercannon rotate 25*x translate <-5,10,0>}
        
        torus {3, 0.3 rotate 90*z translate <3,9,0>}
        torus {3, 0.3 rotate 90*z translate <-3,9,0>}
        cylinder {<3,9,0>, <-3,9,0>, 0.3}
        cylinder {<3,2,1>, <3,9,0>, 0.3}
        cylinder {<-3,2,1>, <-3,9,0>, 0.3}
        cylinder {<4,2,-2>, <3,9,0>, 0.3}
        cylinder {<-4,2,-2>, <-3,9,0>, 0.3}
        object {dish1 rotate 25*x scale 0.25 translate <0,12,-1>}
}

/// END biggun02


#declare webstrutquart =
union {
        torus {50, 3 rotate 90*x translate 60*z}
        torus {50, 3 rotate 75*x translate 60*z}
        torus {50, 3 rotate 60*x translate 60*z}
        torus {50, 3 rotate 45*x translate 60*z}
        torus {50, 3 rotate 30*x translate 60*z}
        torus {50, 3 rotate 15*x translate 60*z}
}

#declare strutsphere = 
union {
        sphere {<0,0,60>, 50}
        object {webstrutquart}
        object {webstrutquart rotate 180*z}
        object {webstrutquart rotate  90*z}
        object {webstrutquart rotate 270*z}    
        torus {49, 3 rotate  45*z translate 60*z}
        torus {49, 3 rotate -45*z translate 60*z}
        sphere {
                <0,0,60>, 54 
                material {T_2}
                translate -60*z 
                rotate -60*y     
                rotate 25*z
                translate 60*z
        }
}

#declare strutsphere1 = 
union {
        sphere {<0,0,60>, 50}
        object {webstrutquart}
        object {webstrutquart rotate 180*z}
        object {webstrutquart rotate  90*z}
        object {webstrutquart rotate 270*z}    
        torus {49, 3 rotate  45*z translate 60*z}
        torus {49, 3 rotate -45*z translate 60*z}
}

#declare toralball = 
union {
        torus {8, 0.5}
        torus {8, 0.5 rotate 90*z}
        torus {8, 0.5 rotate 90*x}
        rotate 45*y
        rotate 45*x
        rotate 45*z 
}

#declare toralstrutsect = 
union {
        object {toralball}
        cylinder {<0,0,-8>, <0,0,8>, 3} 
}

#declare toralstrutsectwheel = 
union {
        object {toralball}
        cylinder {<0,0,-8>, <0,0,8>, 3} 
        cylinder {<-10,-4,0>, <-10,4,0>, 4}
        cylinder {<-10,-6,0>, <-10,6,0>, 2}
        cylinder {<-12,5,0>, <-50,20,0>, 1}
        cylinder {<-12,-5,0>, <-50,-20,0>, 1}
}

#declare toralstrut40 = 
union {
        object {toralstrutsect}
        object {toralstrutsect translate   8*z}
        object {toralstrutsect translate  -8*z}
        object {toralstrutsect translate  16*z}
        object {toralstrutsect translate -16*z}
        object {toralstrutsect translate  24*z}
        object {toralstrutsect translate -24*z}
        object {toralstrutsect translate  32*z}
        object {toralstrutsect translate -32*z}
        object {toralstrutsect translate  40*z}
        object {toralstrutsect translate -40*z}
}

// *********** amsalp barrel ******************************
#declare amsalpbarrel = 
union {
        cone {<0,0,0>, 0.5, <0,0,10>, 0}
        cone {<0,0,0>, 0.5, <0,0,-25>, 0.1}
        object {spotlamp3 rotate 180*y translate <0,2,10>}
        object {spotlamp3 rotate 180*y translate <0,-2,10>}
        object {spotlamp3 translate <2,0,10>}
        object {spotlamp3 translate <-2,0,10>}
        
        object {dish1 scale 0.5 translate 15*z material {T_3}}
        cylinder {<4.5,0,-14>, <4.5,0,14>, 0.2}
        cylinder {<-4.5,0,-14>, <-4.5,0,14>, 0.2}
        cylinder {<0,4.5,-14>, <0,4.5,14>, 0.2}
        cylinder {<0,-4.5,-14>, <0,-4.5,14>, 0.2}
        
        object {dish1 scale 0.2 rotate 170*y translate <6,0,-10>}
        object {spotlamp3 rotate 170*y translate <6,0,-9.5>}
        cylinder {<8,0,-9>, <4.5,0,14>, 0.2}
        object {dish1 scale .2 rotate -170*y translate <-6,0,-10>}
        object {spotlamp3 rotate -170*y translate <-6,0,-9.5>}
        cylinder {<-8,0,-9>, <-4.5,0,14>, 0.2}
        object {dish1 scale 0.2 rotate -170*x translate <0,6, -10>}
        object {spotlamp3 rotate -170*x translate <0,6,-9.5>}
        cylinder {<0,8,-9>, <0,4.5,14>, 0.2}
        object {dish1 scale 0.2 rotate 170*x translate <0,-6,-10>}
        object {spotlamp3 rotate  170*x translate<  0,-6, -9.5>}
        cylinder {<0,-8,-9>, <0,-4.5,14>, 0.2}
        torus {8, 0.2 rotate 90*x translate -9*z}
        torus {4.5, 0.2 rotate 90*x translate -14*z}
        cone {<5,0,17>, 0.2 <7,0, -4>, 1}
        object {spotlamp3 rotate 10*y translate <7,0,-4.1>}
        cone {<-5,0,17>, 0.2 <-7,0, -4>, 1}
        object {spotlamp3 rotate -10*y translate <-7,0,-4.1>}
        cone {<0,5,17>, 0.2 <0,7, -4>, 1}
        object {spotlamp3 rotate -10*x translate <0,7,-4.1>}
        cone {<0, -5,17>, 0.2 <0, -7, -4>, 1}
        object {spotlamp3 rotate 10*x translate <0,-7,-4.1>}
        
        torus {7, 0.6 rotate 90*x}
        torus {7.5, 0.6 rotate 90*x translate 5*z}
        object {strutsphere1 scale <0.1,0.1,0.05> translate 14*z}
}

// ***********  amsalp turret *********************
#declare amsalpturret = 
union {
        object {amsalpbarrel rotate 20*x}
        torus {4, 0.5 rotate 90*z translate  10*x}
        torus {4, 0.5 rotate 90*z translate -10*x}
        object {turretballminus scale 0.25 translate  15*x}
        object {ballmountminus scale 0.25 rotate -65*y translate  15*x}
        object {turretballminus scale 0.25 translate -15*x}
        object {ballmountminus scale 0.25 rotate  65*y translate -15*x}
        cylinder {<10,0,0>, <10,-17,7>, 0.75}
        cylinder {<10,0,0>, <10,-17,-7>, 0.75}
        cylinder {<-10,0,0>, <-10,-17,7>, 0.75}
        cylinder {<-10,0,0>, <-10,-17,-7>, 0.75}
        difference {
                sphere {<0,3,0>, 22}
                sphere {<0,6,0>, 24.2}
                scale 1.3*x
        }
        cone {<0,-17,0>, 10 <0,-23,0>, 7}
}

// fighter thruster *****************************************
#declare fighterthrust = 
union {     
        #declare booster = 
        union { 
                cylinder {<0,0,-3>, <0,0,3> 1}
                cone {<0,0,3>, 1, <0,0,6>, 2 open}
                cone {<0,0,-3>, 1, <0,0,-6>, 0.2}
                difference {
                        sphere {0, 1 scale 2*z translate <1,0,3>}
                        cone {<0.5,0,3>, 0.1, <0.5,0,-3>, 2 scale 2*x material {T_1}}
                }
                difference {
                        sphere {0, 1 scale 2*z translate <-1,0,3>}
                        cone {<-0.5,0,3>, 0.1, <-0.5,0,-3>, 2 scale 2*x material {T_1}}
                }
                difference {
                        sphere {0, 1 scale 2*z translate <0,1,3>}
                        cone {<0,0.5,3>, 0.1, <0,0.5,-3>, 2 scale 2*y material {T_1}}
                }
                difference {
                        sphere {0, 1 scale 2*z translate <0,-1,3>}
                        cone {<0,-0.5,3>, 0.1, <0,-0.5,-3>, 2 scale 2*y material {T_1}}
                }                
        }       
        difference {
                object {booster}
                cylinder {<0,1,-5>, <0,1,3.5>, 0.4 material {T_3}}
                cylinder {<0,-1,-5>, <0,-1,3.5>, 0.4 material {T_3}}
                cylinder {<1,0,-5>, <1,0,3.5>, 0.4 material {T_3}}
                cylinder {<-1,0,-5>, <-1,0,3.5>, 0.4 material {T_3}}
        }
        torus {2, 0.2 rotate 110*x translate 4*z}
        torus {2, 0.2 rotate  70*x translate 4*z}
        torus {2, 0.2 rotate 110*x rotate 90*z translate 4*z}
        torus {2, 0.2 rotate  70*x rotate 90*z translate 4*z} 
        torus {2, 0.2 rotate  45*z scale 2*z}
        torus {2, 0.2 rotate -45*z scale 2*z}
}
// END - fighter thruster *****************************************



// driller door --------------------------------
#declare portal = 
union {
        difference {
                intersection {    
                        object {strutsphere scale <1.5,1.5,1.9> translate -115*z}
                        cylinder {<0,60,0>, <0,100,0>, 50}
                }
                box {<-60,50,-60>, <0,100,60>}
        }
}

#declare toralsphere1 = 
union {
        torus {8, 0.25}
        torus {8, 0.25 rotate 90*z}
        torus {8, 0.25 rotate 90*x}
        rotate 45*y
        rotate 45*x
}

//  ssscockpit with lights********************************

#declare ssscockpit = 
union {
        difference {
                blob {
                        threshold 0.5
                        sphere {<0,0,0>, 20, 1 scale 1.7*z}
                        sphere {<-5,-5,-5>, 10, 1 scale 1.7*z}
                        sphere {<5,-5,-5>, 10, 1 scale 1.7*z}
                }
                sphere {<0,0,0>, 10.5 scale 1.7*z material {T_3}}
                box {<-5,8.3,-15>, <5,9.3,0> material {T_3}}
                box {<-5,6.5,-15>, <5,8,0> material {T_3}}
                box {<-5,5,-15>, <5,6,0> material {T_3}}
                box {<5.5,8.3,-15>, <10,9.3,0> material {T_3}}
                box {<5.5,6.5,-15>, <10,8,0> material {T_3}}
                box {<5.5,5,-15>, <10,6,0> material {T_3}}
                box {<-5.5,8.3,-15>, <-10,9.3,0> material {T_3}}
                box {<-5.5,6.5,-15>, <-10,8,0> material {T_3}}
                box {<-5.5,5,-15>, <-10,6,0> material {T_3}}
        }
        torus {10, 1 scale 1.8*z rotate 90*z}
        torus {10, 0.5 scale 1.6*z rotate 90*z translate 5*x}
        torus {10, 0.5 scale 0.8*x rotate 90*z translate 9*x}
        torus {10, 0.5 scale 1.6*z rotate 90*z translate -5*x}
        torus {10, 0.5 scale 0.8*x rotate 90*z translate -9*x}
                   
        torus {10, 0.5 scale 1.1   rotate  90*x}
        torus {10, 0.5 scale 0.8*x rotate  30*z translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate  60*z translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate -30*z translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate -30*z translate <-6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate -60*z translate <-6,-5,-15>}
        torus {10, 0.5 scale 0.8*x translate <-6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate  30*z translate <-6,-5,-15>}
        torus {10, 0.5 scale 1.3*z rotate -30*x translate <0,5,-10>}
}
// end of ssscockpit ============================

//  ssscockpit2 with lights********************************

#declare ssscockpit2 = 
union {
        difference {
                blob {
                        threshold 0.5
                        sphere {<0,0,0>, 20, 1 scale 1.7*z}
                        sphere {<-5,-5,-5>, 10, 1 scale 1.7*z}
                        sphere {<5,-5,-5>, 10, 1 scale 1.7*z}
                }
                sphere {<0,0,0>, 10.5 scale 1.7*z material {T_3}}
                sphere {<15,10,-15>, 10 scale 1.7*z rotate 15*x material {T_3}}
                sphere {<11,7,-5>, 9 scale <0.4,0.6,1.5> material {T_3}}
                sphere {<-11,7,-5>, 9 scale <0.4,0.6,1.5> material {T_3}}
        }
        torus {10, 1 scale 1.8*z rotate 90*z}
        torus {10, 0.5 scale 1.6*z rotate 90*z translate 5*x}
        torus {10, 0.5 scale 0.8*x rotate 90*z translate 9*x}
        torus {10, 0.5 scale 1.6*z rotate 90*z translate -5*x}
        torus {10, 0.5 scale 0.8*x rotate 90*z translate -9*x}
                  
        torus {10, 0.5 scale 1.3*x rotate 90*x translate -5*z}
        torus {9, 0.5 scale 1.3*x rotate 90*x translate -9*z}
        torus {7.5, 0.5 scale 1.2*x rotate 90*x translate -12*z}
        torus {5.5, 0.5 scale 1.2*x rotate 90*x translate -15*z}
        
        torus {10, 0.5 scale 1.1 rotate 90*x}
        torus {10, 0.5 scale 0.8*x rotate 30*z translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate 60*z translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate -30*z translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate -30*z translate <-6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate -60*z translate <-6,-5,-15>}
        torus {10, 0.5 scale 0.8*x translate <-6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate 30*z translate <-6,-5,-15>}
        torus {10, 0.5 scale 1.3*z rotate -30*x translate <0,5,-10>}
}
// end of ssscockpit2 ============================

// SSS drive section *******************
#declare sssdrive = 
merge {
        blob {
                threshold 0.5
                sphere {<0,0,0>, 13, 1 scale 1.5*z}
                sphere {<5,5,6>, 7, 1 scale 1.3*z}
                sphere {<-5,5,6>, 7, 1 scale 1.3*z}
                sphere {<5,-5,6>, 7, 1 scale 1.3*z}
                sphere {<-5,-5,6>, 7, 1 scale 1.3*z}
                sphere {<4,4,0>, 4, 1 scale 1.5*z}
                sphere {<-4,4,0>, 4, 1 scale 1.5*z}
                sphere {<4,-4,0>, 4, 1 scale 1.5*z}
                sphere {<-4,-4,0>, 4, 1 scale 1.5*z}
        }
        cone {<5,5,3>, 0, <5,5,18>, 5 open material {T_2}}
        cone {<-5,5,3>, 0, <-5,5,18>, 5 open material {T_2}}
        cone {<5,-5,3>, 0, <5,-5,18>, 5 open material {T_2}}
        cone {<-5,-5,3>, 0, <-5,-5,18>, 5 open material {T_2}}
        torus {6, 0.5 rotate 90*x translate -6*z}
        torus {7, 0.5 rotate 90*x translate -3*z}
        torus {8, 0.5 rotate 90*x}
        torus {9, 0.5 rotate 90*x translate  3*z}
        torus {10, 0.5 rotate 90*x translate  5*z}
        torus {11, 0.5 rotate 90*x translate  7*z}
        torus {10, 0.5 rotate 90*x translate 10*z}
        torus {10, 0.5 rotate 90*z}
        torus {10, 0.5}
}
// END    SSS drive section *******************


// SIMPLE SSS ///////////////////////////////////////

// SIMPLE SSS drive section *******************
#declare simplesssdrive = 
merge {
        blob {
                threshold 0.5
                sphere {<0,0,0>, 13, 1 scale 1.5*z}
                sphere {<5,5,6>, 7, 1 scale 1.3*z}
                sphere {<-5,5,6>, 7, 1 scale 1.3*z}
                sphere {<5,-5,6>, 7, 1 scale 1.3*z}
                sphere {<-5,-5,6>, 7, 1 scale 1.3*z}
                sphere {<4,4,0>, 4, 1 scale 1.5*z}
                sphere {<-4,4,0>, 4, 1 scale 1.5*z}
                sphere {<4,-4,0>, 4, 1 scale 1.5*z}
                sphere {<-4,-4,0>, 4, 1 scale 1.5*z}
        }
        cone {<5,5,3>, 0, <5,5,18>, 5 open material {T_2}}
        cone {<-5,5,3>, 0, <-5,5,18>, 5 open material {T_2}}
        cone {<5,-5,3>, 0, <5,-5,18>, 5 open material {T_2}}
        cone {<-5,-5,3>, 0, <-5,-5,18>, 5 open material {T_2}}
        torus {6, 0.5 rotate 90*x translate -6*z}
        torus {8, 0.5 rotate 90*x}
        torus {10, 0.5 rotate 90*x translate 5*z}
        torus {11, 0.5 rotate 90*x translate 7*z}
        torus {10, 0.5 rotate 90*z}
        torus {10, 0.5}
}
// END    SSS drive section *******************

//  simple ssscockpit no lights********************************

#declare simplessscockpit = 
union {
        blob {
                threshold 0.5
                sphere {<0,0,0>, 20, 1 scale 1.7*z}
                sphere {<-5,-5,-5>, 10, 1 scale 1.7*z}
                sphere {<5,-5,-5>, 10, 1 scale 1.7*z}
        }
        torus {10, 1 scale 1.8*z rotate 90*z}
        torus {10, 0.5 scale 0.8*x rotate 90*z translate 9*x}
        torus {10, 0.5 scale 0.8*x rotate 90*z translate -9*x}
        torus {10, 0.5 scale 1.1 rotate 90*x}
        torus {10, 0.5 scale 0.8*x rotate 30*z translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x translate <6,-5,-15>}
        torus {10, 0.5 scale 0.8*x rotate -30*z translate <-6,-5,-15>}
        torus {10, 0.5 scale 0.8*x translate <-6,-5,-15>}
        torus {10, 0.5 scale 1.3*z rotate -30*x translate <0,5,-10>}
}
// end of ssscockpit ============================

#declare simplesss = 
union {
        object {simplesssdrive scale 2 translate 50*z}
        object {simplessscockpit translate -50*z}
        cylinder {<0,0,45>, <0,0,-45>, 8}
        object {lasercannondull scale 5 translate <35,0,0>}
        object {lasercannondull scale 5 translate <-35,0,0>}
        object {toralsphere1 scale <6,1,4>}
}

// END OF SIMPLE SSS ///////////////////////////////////////

// Dirac drive section *******************
#declare diracdrive = 
merge {
        blob {
                threshold 0.8
                sphere {<0,0,0>, 13, 1 scale 1.5*z}
                sphere {<5,5,6>, 7, 1 scale 1.3*z}
                sphere {<-5,5,6>, 7, 1 scale 1.3*z}
                sphere {<5,-5,6>, 7, 1 scale 1.3*z}
                sphere {<-5,-5,6>, 7, 1 scale 1.3*z}
                sphere {<4,4,0>, 4, 1 scale 1.5*z}
                sphere {<-4,4,0>, 4, 1 scale 1.5*z}
                sphere {<4,-4,0>, 4, 1 scale 1.5*z}
                sphere {<-4,-4,0>, 4, 1 scale 1.5*z}
        }
        cone {<0,0,3>, 0, <0,0,20>, 9 open material {T_2}}
        cone {<4,4,3>, 0, <7,7,18>, 3 open material {T_2}}
        cone {<-4,4,3>, 0, <-7,7,18>, 3 open material {T_2}}
        cone {<4,-4,3>, 0, <7,-7,18>, 3 open material {T_2}}
        cone {<-4,-4,3>, 0, <-7,-7,18>, 3 open material {T_2}}
        torus {3, 1 rotate 90*x translate -6*z}
        torus {7, 1 rotate 90*x}
        torus {10, 1 rotate 90*x translate  7*z}
        torus {9, 1 rotate 90*x translate 13*z}
        torus {9, 1 rotate 90*z}
        torus {9, 1}
}
// END    SSS drive section *******************  

#declare fingers = 
union {
        torus {6, 0.4 translate -5*z}
        torus {6, 0.4 rotate  90*z translate -5*z}
        torus {6, 0.4 rotate  45*z translate -5*z}
        torus {6, 0.4 rotate -45*z translate -5*z}
        torus {6, 0.4 scale 1.5*z  translate -5*z}
        torus {6, 0.4 rotate  90*z scale 1.5*z translate -5*z}
        torus {6, 0.4 rotate  45*z scale 1.5*z translate -5*z}
        torus {6, 0.4 rotate -45*z scale 1.5*z translate -5*z}
        material {T_2}
}

#declare claw = 
union {
        sphere {<0,0,1>, 2}
        object {boxsect3 scale 0.4 rotate <45,45,0> translate <0,0,1>}
        difference {
                object {fingers}
                cylinder {<0,0,-20> <0,0,-5> 6 material {T_1}}
        }
}

#declare limbthing = 
union {
        sphere {<0,0,6>, 2.5 scale <1,1,1.3>}
        torus {4.5, 0.5 translate <0,0,6>}
        torus {4.5, 0.5 rotate 90*z translate <0,0,6>}
        torus {4.5, 0.5 rotate 90*x translate <0,0,6>}
        object {boxsect3 scale 0.4 translate <0,0,6>}
        object {boxsect3 scale 0.4 translate <0,0,3>}
        object {boxsect3 scale 0.4 translate <0,0,0>}
        object {boxsect3 scale 0.4 translate <0,0,-3>}
        object {boxsect3 scale 0.4 translate <0,0,-6>}
        cylinder {<0,0, -9> <0,0,9> 0.8}
        sphere {<0,0, -6> 2.5 scale <1,1,1.3>}
        torus {4.1, 0.3 translate <0,0,-6>}
        torus {4.1, 0.3 rotate 90*z translate <0,0,-6>}
        torus {4.1, 0.3 rotate 90*x translate <0,0,-6>}
        cylinder {<2.5,0,-9.5>, <2.5,0,9.5>, 0.4}
        cylinder {<-2.5,0,-10>, <-2.5,0,10>, 0.4}
        cylinder {<0,2.5,-10>, <0,2.5,10>, 0.4}
        cylinder {<0,-2.5,-10>, <0,-2.5,10>, 0.4}
}

#declare arm = 
union {
        sphere {<0,0,0>, 3}
        object {limbthing rotate <45,-45,0> translate <5.4,5.9,-3.5>}
        object {limbthing rotate <-25,25,0> translate <6,7,-15>}
        object {claw translate <3.5,3.5,-29>}
}

#declare diracfront = 
union {
        blob {
                threshold 0.5
                sphere {<0,0,0>, 13, 1 scale 1.5*z}
                sphere {<5,5,6>, 7, 1 scale 1.3*z}
                sphere {<-5,5,6>, 7, 1 scale 1.3*z}
                sphere {<5,-5,6>, 7, 1 scale 1.3*z}
                sphere {<-5,-5,6>, 7, 1 scale 1.3*z}
                scale 0.7
        }
        object {
                arm rotate -60*z rotate -50*y translate <5,5,2>
                material {T_2}
        }
        object {
                arm rotate 80*z rotate 20*x translate <-5,5,2>
                material {T_2}
        }
        object {
                arm rotate 190*z translate <-5,-5,2>
                material {T_2}
        }
        object {
                arm rotate 20*x rotate 270*z translate <5,-5,2>
                material {T_2}
        }
        object {boxsect3 scale 0.8 translate <0,0,-4>}
        object {boxsect3 rotate 45*z}
        object {lasercannonminus scale 3 translate 13*z} 
}

/// bigger strutty engine
#declare bigengine01 = 
union {
        object {
                strutsphere1
                translate <0,0,-60>
                scale <0.65,0.65,2.5>
                scale 0.4    
                rotate 33*y 
                translate <30,0,50>
        }
        object {
                strutsphere1
                translate <0,0,-60>
                scale <0.65,0.65,2.5>
                scale 0.4    
                rotate -33*y 
                translate <-30,0,50>
        }
        object {
                strutsphere1
                translate <0,0,-60>
                scale <0.65,0.65,2.5>
                scale 0.4    
                rotate 33*y 
                translate <30,0,50>
                rotate 90*z
        } 
        object {
                strutsphere1
                translate <0,0,-60>
                scale <0.65,0.65,2.5>
                scale 0.4    
                rotate 33*y 
                translate <30,0,50>
                rotate -90*z
        }
        difference {
                object {
                        strutsphere1
                        scale <0.9,0.9,1.1>
                        translate 5*z
                }
                sphere {
                        <0,0,60>, 50
                        scale <0.85,0.85,1.1>
                        translate 18*z
                }
        }
        object {engine01 rotate -15*x translate <0,55,90>}
        object {engine01 rotate  15*x translate <0,-55,90>}
        object {engine01 rotate  15*y translate <55,0,90>}
        object {engine01 rotate -15*y translate <-55,0,90>}
}

#declare ovalstrutquart = 
union {
        object {toralstrutsect scale 1.25 translate 50*x}
        object {toralstrutsect scale 1.25 rotate  -7*y translate <49,0, 8>}
        object {toralstrutsect scale 1.25 rotate -13*y translate <48,0,16>}
        object {toralstrutsect scale 1.25 rotate -17*y translate <47,0,24>}
        object {toralstrutsect scale 1.25 rotate -22*y translate <45,0,32>}
        object {toralstrutsect scale 1.25 rotate -26*y translate <42,0,40>}
        object {toralstrutsect scale 1.25 rotate -30*y translate <39,0,46>}
        object {toralstrutsect scale 1.25 rotate -37*y translate <35,0,53>}
        object {toralstrutsect scale 1.25 rotate -45*y translate <30,0,59>}
        object {toralstrutsect scale 1.25 rotate -53*y translate <22,0,66>}
        object {toralstrutsect scale 1.25 rotate -60*y translate <14,0,71>}
        object {toralstrutsect scale 1.25 rotate -70*y translate <7,0,74>}
        object {toralstrutsect scale 1.25 rotate -90*y translate <0,0,75>}
} 

#declare ovalstrutoval = 
union {
        object {ovalstrutquart}
        object {ovalstrutquart rotate 180*z}
        object {ovalstrutquart rotate 180*x}
        object {ovalstrutquart rotate 180*z rotate 180*x}
}

/// SIMPLE DIRAC FOR CARRIER //////////////////////////////////
#declare simplefingers = 
union {
        difference {
                sphere {<0,0,0>, 6}
                box {<-7,-2,-8>, <7,2,3>}
                box {<-7,-2,-8>, <7,2,3> rotate 120*z}
                box {<-7,-2,-8>, <7,2,3> rotate 240*z}
        }
        material {T_2}
}

#declare simpleclaw = 
union {
        sphere {<0,0,1>, 2}
        object {boxsect3 scale 0.4 rotate <45,45,0> translate <0,0,1>}
        difference {
                object {simplefingers}
                cylinder {<0,0,-20>, <0,0,-5>, 6 material {T_1}}
        }
}

#declare limbthing2 = 
union {
        sphere {<0,0,6>, 2.5 scale <1,1,1.3>}
        cylinder {<0,0,-9>, <0,0,9>, 2}
}

#declare simplearm = 
union {
        sphere {<0,0,0>, 3}
        object {limbthing2 rotate <45,-45,0> translate <5.4,5.9,-3.5>}
        object {limbthing2 rotate <-25,25,0> translate <6,7,-15>}
        object {simpleclaw translate <3.5,3.5,-29>}
}

#declare simplediracfront = 
union {
        blob {
                threshold 0.5
                sphere {<0,0,0>, 13,1 scale 1.5*z}
                sphere {<5,5,6>,7,1 scale 1.3*z}
                sphere {<-5,5,6>,7,1 scale 1.3*z}
                sphere {<5,-5,6>,7,1 scale 1.3*z}
                sphere {<-5,-5,6>,7,1 scale 1.3*z}
                scale 0.7
        }
        object {simplearm rotate -60*z rotate -50*y translate <5,5,2>}
        object {simplearm rotate 80*z rotate 20*x translate <-5,5,2>}
        object {simplearm rotate 190*z translate <-5,-5,2>}
        object {simplearm rotate 20*x rotate 270*z translate <5,-5,2>}
}

#declare simpledirac = 
union {
        object {boxsect3 translate -8*z}
        object {boxsect3 }
        object {boxsect3 translate 8*z}
        object {simplediracfront translate -20*z}
        object {diracdrive scale 1.3 translate 10*z}
}

/// END OF SIMPLE DIRAC FOR CARRIER ////////////////////////////////// 

/// SIMPLE BISMUTH FOR CARRIER ////////////////////////////////// 

// simple fighter thruster *****************************************
#declare simplefighterthrust = 
union { 
        #declare simplebooster = 
        union {
                cylinder {<0,0,-3>, <0,0,3>, 1}
                cone {<0,0,3>, 1 <0,0,6>, 2 open}
                cone {<0,0,-3>, 1, <0,0,-6>, 0.2}
                difference {
                        sphere {0, 1 scale 2*z translate <1,0,3>}
                        cone {<0.5,0,3>, 0.1, <0.5,0,-3>, 2 scale 2*x material {T_1}}
                }                      
                difference {
                        sphere { 0, 1 scale 2*z translate <-1,0,3>}
                        cone {<-0.5,0,3> 0.1, <-0.5,0,-3>, 2 scale 2*x material {T_1}}
                }
                difference {
                        sphere {0, 1 scale 2*z translate <0,1,3>}
                        cone {<0,0.5,3>, 0.1, <0,0.5,-3>, 2 scale 2*y material {T_1}}
                }
                difference {
                        sphere {0, 1 scale 2*z translate <0,-1,3>}
                        cone {<0,-0.5,3>, 0.1, <0,-0.5,-3>, 2 scale 2*y material {T_1}}
                }
        }
        object {simplebooster}

}
// END - simple fighter thruster *****************************************

#declare simplebismuth = 
union {
        object {toralsphere1 scale 2}
        object {toralsphere1 scale 1.5 translate -10*z}
        object {toralsphere1 scale 0.85 translate -20*z}
        object {toralsphere1 scale 1.8 translate 5*z}
        object {toralsphere1 scale 1.2 translate 15*z}
        object {simplefighterthrust scale 4 translate <20,0,10>}
        object {simplefighterthrust scale 4 translate <-20,0,10>}
        torus {7, 0.5 rotate 90*x rotate -30*y scale 2*x translate  17*x}
        torus {7, 0.5 rotate 90*x rotate  30*y scale 2*x translate -17*x}
        torus {7, 0.5 rotate 90*x rotate -30*y scale 2*x translate  19*x translate 10*z}
        torus {7, 0.5 rotate 90*x rotate  30*y scale 2*x translate -19*x translate 10*z}
        object {cagedull rotate 30*x rotate 20*y scale .5 translate 13*y}
        object {cagedull rotate 90*x scale 0.5 translate 13*y}
        object {lasercannondull scale <2,2,3> translate <9,9,0>}
        object {lasercannondull scale <2,2,3> translate <-9,9,0>}
        object {lasercannondull scale <2,2,3> translate <9,-9,0>}
        object {lasercannondull scale <2,2,3> translate <-9,-9,0>}
}

/// END OF SIMPLE BISMUTH FOR CARRIER ////////////////////////////////// 

#declare diracstrutsect = 
union {
        object {toralstrutsectwheel }
        object {simpledirac rotate -90*y scale 0.15 translate <0,8,3>  material {T_1}}
        object {simpledirac rotate -90*y scale 0.15 translate <0,8,-3>  material {T_1}}
        object {simpledirac rotate -90*y scale 0.15 translate <0,-8,3>  material {T_1}}
        object {simpledirac rotate -90*y scale 0.15 translate <0,-8,-3>  material {T_1}}
        object {simpledirac rotate -90*y scale 0.15 translate <8,0,3>  material {T_1}}
        object {simpledirac rotate -90*y scale 0.15 translate <8,0,-3>  material {T_1}}
}

#declare sss_strutsect = 
union {
        object {toralstrutsectwheel}
        object {simplesss rotate -90*y scale 0.1 translate <0,9,4> material {T_1}}
        object {simplesss rotate -90*y scale 0.1 translate <0,9,-4> material {T_1}}
        object {simplesss rotate 180*z rotate -90*y scale 0.1 translate <0,-9,4> material {T_1}}
        object {simplesss rotate 180*z rotate -90*y scale 0.1 translate <0,-9,-4> material {T_1}}
        object {simplesss rotate -90*z rotate -90*y scale 0.1 translate <10,0,4> material {T_1}}
        object {simplesss rotate  90*z rotate -90*y scale 0.1 translate <10,0,-4> material {T_1}}
}

#declare bismuthstrutsect = 
union {
        object {toralstrutsectwheel }
        object {simplebismuth rotate -90*y scale 0.2 translate <0,8,0> material {T_5}}
        object {simplebismuth rotate 180*z rotate -90*y scale 0.25 translate <0,-8,0> material {T_5}}
        object {simplebismuth rotate 180*z rotate -90*y scale 0.25 translate <10,0,0> material {T_5}}
}

#declare ovalstrutquart1 = 
union {
        object {diracstrutsect scale 0.75 translate 50*x}
        object {diracstrutsect scale 0.75 rotate  -7*y translate <49,0,8>}
        object {diracstrutsect scale 0.75 rotate -13*y translate <48,0,16>}
        object {diracstrutsect scale 0.75 rotate -17*y translate <47,0,24>}
        object {diracstrutsect scale 0.75 rotate -22*y translate <45,0,32>}
        object {sss_strutsect scale 0.75 rotate -26*y translate <42,0,40>}
        object {sss_strutsect scale 0.75 rotate -30*y translate <39,0,46>}
        object {sss_strutsect scale 0.75 rotate -37*y translate <35,0,53>}
        object {sss_strutsect scale 0.75 rotate -45*y translate <30,0,59>}
        object {bismuthstrutsect scale 0.75 rotate -53*y translate <22,0,66>}
        object {bismuthstrutsect scale 0.75 rotate -60*y translate <14,0,71>}
        object {bismuthstrutsect scale 0.75 rotate -70*y translate <7,0,74>}
        object {bismuthstrutsect scale 0.75 rotate -90*y translate <0,0,75>}
} 

#declare ovalstrutoval1 = 
union {
        object {ovalstrutquart1}
        object {ovalstrutquart1 rotate 180*z}
        object {ovalstrutquart1 rotate 180*x}
        object {ovalstrutquart1 rotate 180*z rotate 180*x}
}

#declare carousel = 
union {
        object {ovalstrutoval1 scale 0.8 rotate 90*x material {greebleMat scale 50 rotate x*90}}
        object {strutsphere1 scale <0.6,0.4,0.9>*0.8 translate -55*z rotate 90*x material {greebleMat scale 50 rotate x*90}}
        object {toralstrut40 scale <0.4,0.4,1.2> rotate 90*x translate -30*z rotate 90*z material {greebleMat scale 50 rotate x*90}}
        object {toralstrut40 scale <0.4,0.4,1.2> rotate 90*x translate  30*z rotate 90*z material {greebleMat scale 50 rotate x*90}}
}

//  spike ------------------------------
#declare spike = 
merge {
        difference {
                cone {<0,0,20>, 20, <0,0,-60>, 1 open}
                cylinder {<20,0,15>, <-20,0,15>, 5 rotate 45*z}
                cylinder {<0,20,15>, <0,-20,15>, 5 rotate 45*z} 
                cylinder {<20,0,10>, <-20,0,10>, 8}
                cylinder {<0,20,10>, <0,-20,10>, 8}
                cylinder {<20,0,-5>, <-20,0,-5>, 6 rotate 45*z}
                cylinder {<0,20,-5>, <0,-20,-5>, 6 rotate 45*z} 
                cylinder {<20,0,-15>, <-20,0,-15>, 6}
                cylinder {<0,20,-15>, <0,-20,-15>, 6} 
                cylinder {<20,0,-30>, <-20,0,-30>, 4}
                cylinder {<0,20,-30>, <0,-20,-30>, 4} 
                cylinder {<20,0,-40>, <-20,0,-40>, 4}
                cylinder {<0,20,-40>, <0,-20,-40>, 4}                                   
                cylinder {<6,0,-15>, <6,0,-70>, 4}
                cylinder {<-6,0,-15>, <-6,0,-70>, 4}
                cylinder {<0,6,-15>, <0,6,-70>, 4}
                cylinder {<0,-6,-15>, <0,-6,-70>, 4}
        }
}

// rammer spike ------------------------------

#declare rammer = 
union {
        object {spike}
        object {spike scale <0.5,0.5,0.7> rotate <0,-25,0> translate  15*x}
        object {spike scale <0.5,0.5,0.7> rotate <0, 25,0> translate -15*x}
        object {spike scale <0.5,0.5,0.7> rotate <25,0,0> translate  15*y}
        object {spike scale <0.5,0.5,0.7> rotate <-25,0,0> translate -15*y}
        torus {24, 1 rotate  60*x}
        torus {24, 1 rotate -60*x}
        torus {18, 1 rotate  60*x rotate 90*z}
        torus {18, 1 rotate -60*x rotate 90*z}
        torus {14, 1 rotate  60*x translate -20*z}
        torus {14, 1 rotate -60*x translate -20*z}
        torus {14, 1 rotate  60*x rotate 90*z translate -20*z}
        torus {14, 1 rotate -60*x rotate 90*z translate -20*z}
        torus {6, 0.5 rotate  60*x scale 2*z translate -35*z}
        torus {6, 0.5 rotate -60*x scale 2*z translate -35*z}
        torus {6, 0.5 rotate  60*x rotate 90*z scale 2*z translate -35*z}
        torus {6, 0.5 rotate -60*x rotate 90*z scale 2*z translate -35*z}
}
///// end rammer --------------------------------

// - RAMMING BOW SECTION ---------------------------
#declare rammingthing = 
union {
        object {strutsphere1 scale <0.5,0.5,1>}
        object {rammer scale 1.7*z translate -20*z}
        object {rammer rotate -30*y scale 0.8 translate  50*x}
        object {rammer rotate  30*y scale 0.8 translate -50*x}
        object {rammer rotate -30*x scale 0.8 translate -50*y}
        object {rammer rotate  30*x scale 0.8 translate  50*y}
        
        object {strutsphere1 translate <0,0,-60> scale <0.8,0.8,2.5> scale 0.4 rotate  25*y translate <-30,0,50>}
        object {strutsphere1 translate <0,0,-60> scale <0.8,0.8,2.5> scale 0.4 rotate -25*y translate <30,0,50>}
        object {strutsphere1 translate <0,0,-60> scale <0.8,0.8,2.5> scale 0.4 rotate -25*y translate <30,0,50> rotate -90*z}
        object {strutsphere1 translate <0,0,-60> scale <0.65,0.65, 2.5> scale 0.4 rotate -25*y translate <30,0,50> rotate 90*z}
}
// - END RAMMING BOW SECTION ---------------------------

#declare loaders = 
union {
        object {simplearm scale 0.3 rotate 90*x rotate -45*z material {T_6}}
        object {simplearm scale 0.3 rotate 90*x rotate -45*z rotate 160*x material {T_6}}
        object {toralstrut40 scale <0.4,0.4,0.25> rotate -90*x translate <0,9,0> rotate -40*z material {T_4}}
        object {toralstrut40 scale <0.4,0.4,0.25> rotate -90*x translate <0,9,0> rotate -40*z rotate 180*x material {T_4}} 
        object {rammingthing scale 0.06 rotate 90*x translate <0,22,0> rotate -40*z material {T_4}} 
        object {rammingthing scale 0.06 rotate 90*x translate <0,22,0> rotate -40*z rotate 180*x material {T_4}}
}

#declare fighterbay1 = 
union {
        object {carousel}
        object {loaders translate <60,0,-30>}
        object {loaders translate <60,0,-30> rotate 180*x}
        object {loaders translate <60,0,-30> rotate 180*z}
        object {loaders translate <60,0,-30> rotate 180*z rotate 180*x}
}

/// METRO BRIDGE STRUCTURE
#declare metrobridge = 
union {
        object {toralstrut40 scale <0.8,0.8,0.8> rotate 90*y translate <40,0,0> material {T_2}}
        object {bridge_room2 scale 2.5 translate <90,0,0> material {T_2}}
        //object {bridge_room2 scale 2.5 translate <-90 ,0, 0> material {T_2}}
}
// END metrobridge


// metro nav bridge
#declare metnavbridge = 
union {
        object {toralstrut40 scale <0.8,0.8,1> rotate 90*x material {T_2}}
        object {bridge_room2 scale 2.5 translate <0,50,0> material {T_2}}
        object {bridge_room2 rotate 180*z scale 2.5 translate <0,-50,0> material {T_2}}
}
// END Metro nav bridge 

/// cluster emgine ---------------------

#declare clusterdrive = 
union {    
        object {bigengine01 scale <0.7,0.5,0.9> translate <0,0,-70> material {T_2}}    
        object {engine01 translate <30,10,0> material {T_2}}
        object {engine01 translate <-30,10,0> material {T_2}}
        object {engine01 translate <30,-10,0> material {T_2}}
        object {engine01 translate <-30,-10,0> material {T_2}}    
        object {
                strutsphere
                translate <0,0,-60>
                scale <0.5,0.5,2.5>
                scale 0.4*0.5
                rotate 30*z    
                rotate 30*y 
                rotate 30*z
                translate <10,10,-35>
                material {T_2}
        }
        object {
                strutsphere
                translate <0,0,-60>
                scale <0.5,0.5,2.5>
                scale 0.4*0.5
                rotate -30*z    
                rotate 30*y 
                rotate -30*z
                translate <10,-10,-35>
                material {T_2}
        }
        object {
                strutsphere
                translate <0,0,-60>
                scale <0.5,0.5,2.5>
                scale 0.4*0.5
                rotate 30*z    
                rotate 30*y 
                rotate 150*z
                translate <-10,10,-35>
                material {T_2}
        }
        object {
                strutsphere
                translate <0,0,-60>
                scale <0.5,0.5,2.5>
                scale 0.4*0.5
                rotate -30*z    
                rotate 30*y 
                rotate -150*z
                translate <-10,-10,-35>
                material {T_2}
        }
} 

#declare clusterdrive2 = 
union {    
        object {bigengine01 scale <0.7,0.5,0.9> translate <0,0,-70>}    
        object {engine01 translate <30,10,0>}
        object {engine01 translate <-30,10,0>}
        object {engine01 translate <30,-10,0>}
        object {engine01 translate <-30,-10,0>}    
        object {
                strutsphere
                translate <0,0,-60>
                scale <0.5,0.5,2.5>
                scale 0.4*0.5
                rotate 30*z    
                rotate 30*y 
                rotate 30*z
                translate <10,10,-35>
        }
        object {
                strutsphere
                translate <0,0,-60>
                scale <0.5,0.5,2.5>
                scale 0.4*0.5
                rotate -30*z    
                rotate 30*y 
                rotate -30*z
                translate <10,-10,-35>
        }
        object {
                strutsphere
                translate <0,0,-60>
                scale <0.5,0.5,2.5>
                scale 0.4*0.5
                rotate 30*z    
                rotate 30*y 
                rotate 150*z
                translate <-10,10,-35>
        }
        object {
                strutsphere
                translate <0,0,-60>
                scale <0.5,0.5,2.5>
                scale 0.4*0.5
                rotate -30*z    
                rotate 30*y 
                rotate -150*z
                translate <-10,-10,-35>
        }
}

#declare w_tower =
union {
        object {clusterdrive2 scale <0.8,0.8,1> translate 120*z material {greebleMat scale 50 rotate x*90}}
        object {toralball scale 2.8 translate 70*z material {greebleMat scale 50 rotate x*90}}
        object {toralball scale 2.3 translate 50*z material {greebleMat scale 50 rotate x*90}}  
        object {toralstrut40 scale <1.5,1.5,2> translate -40*z material {greebleMat scale 50 rotate x*90}}
        object {toralstrut40 scale <0.75,0.75,2.7> translate <0,20,-40> material {greebleMat scale 50 rotate x*90}}
        object {toralstrut40 scale <0.75,0.75,2.7> translate <0,-20,-40> material {greebleMat scale 50 rotate x*90}}
        object {toralstrut40 scale <0.75,0.75,2.7> translate <-20,0,-40> material {greebleMat scale 50 rotate x*90}}
        object {toralstrut40 scale <0.75,0.75,2.7> translate <20,0,-40> material {greebleMat scale 50 rotate x*90}}
        object {rammingthing scale 0.5 translate -180*z material {T_2}}
        object {fighterbay1 rotate z*90 scale 0.8 translate 30*z material {T_2}}
        object {fighterbay1 rotate z*90 scale 0.8 translate -30*z material {T_2}}
        object {fighterbay1 rotate z*90 scale 0.8 translate -90*z material {T_2}}
        object {metnavbridge scale 0.8 rotate x*-90 translate <0,0,-130>  material {T_2}}
        scale 0.01   
        rotate <90,0,0>
}


